       IDENTIFICATION DIVISION.
       PROGRAM-ID. XM059.
      ****************************************************************
      *  XM059   EWIGER KALENDER 1901 - 1999
      *  PARAMETER
      *  ---------
      *        P1: DATUM TT,MM,JJ            8 BYTES  AN
      *
      *        P2: SPRACHCODE 1,2,3
      *           WENN UNGUELTIG = 1         1 BYTE   AN
      *
      *        P3: ALINIERUNG L (LINKS)
      *                       R (RECHTS)
      *             WENN UGUELTIG = L        1 BYTE   AN
      *        P4: WOCHENTAG OUTPUT     10 BYTES  AN
      *
      *        WENN P1 NICH PLAUSIBEL, WIRD P4 MIT '?' GEFUELLT
      *
      *        DIESER KALENDER BERUHT AUF DER TATSACHE, DASS AM
      *        1. JANUAR 1901   D I E N S T A G   WAR.
      ****************************************************************
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
REFINE 77  COMMREG     PIC X(8) VALUE LOW-VALUES.
REFINE 01  ACCEPT-DATE.
REFINE     05  CURRENT-YEAR          PIC 99.
REFINE     05  CURRENT-MONTH         PIC 99.
REFINE     05  CURRENT-DAY           PIC 99.
REFINE 01  ACCEPT-TIME.
REFINE     05  CURRENT-HOUR          PIC 99.
REFINE     05  CURRENT-MINUTE        PIC 99.
REFINE     05  CURRENT-SECOND        PIC 99.
REFINE 01  CURRENT-DATE.
REFINE     05  CURRENT-YEAR          PIC 99.
REFINE     05  FILLER                PIC X VALUE '/'.
REFINE     05  CURRENT-MONTH         PIC 99.
REFINE     05  FILLER                PIC X VALUE '/'.
REFINE     05  CURRENT-DAY           PIC 99.
REFINE 01  TIME-OF-DAY.
REFINE     05  CURRENT-HOUR          PIC 99.
REFINE     05  FILLER                PIC X VALUE '/'.
REFINE     05  CURRENT-MINUTE        PIC 99.
REFINE     05  FILLER                PIC X VALUE '/'.
REFINE     05  CURRENT-SECOND        PIC 99.
      ***************************************************************
       01  DDMMYY.
           02 DD        PIC 99.
RENAME     02 MONTH     PIC 99.
RENAME     02 CENTURY   PIC 99.
REMOVE*  Redefining Field Length does not match Redefined!
RENAME     02 CE-X      REDEFINES CENTURY
RENAME                               PIC XXX.
RENAME     02 YEAR      PIC 99.
REMOVE*  Redefining Field Length does not match Redefined!
RENAME     02 YY-X      REDEFINES YEAR
RENAME                               PIC XXX.
       01  P16          PIC X.
       01  DATUM-NUMBERS.
REMOVE     02 DDP       PIC 999.
REMOVE     02 MMP       PIC 999.
REMOVE     02 YYP       PIC 999.
REMOVE     02 DDB       PIC S9999.
REMOVE     02 MMB       PIC S9999.
REMOVE     02 YYB       PIC S9999.
       01  WORK-DATA-1.
RENAME     02 SPRACHENCODE
RENAME                  PIC 9.
RENAME     02 LEFT-RIGHT-ALIGNMENT
RENAME                  PIC X.
REMOVE     02 DOPPELT   PIC S9(15)        VALUE 0.
REMOVE     02 YTT       PIC S9(8)      VALUE -1.
REMOVE     02 STT       PIC S9(8)      VALUE 0.
REMOVE     02 MTT       PIC S9(8)      VALUE 0.
REMOVE     02 TTT       PIC S9(8)      VALUE 0.
       01  WW.
           02 W1        OCCURS 10 TIMES PIC X.
      *
      ***************************************************************
      *
       01  WOTAB.
           02 FILLER PIC X(30) VALUE 'DIENSTAG  MARDI     MARTEDI   '.
           02 FILLER PIC X(30) VALUE 'MITTWOCH  MERCREDI  MERCOLEDI '.
           02 FILLER PIC X(30) VALUE 'DONNERSTAGJEUDI     GIOVEDI   '.
           02 FILLER PIC X(30) VALUE 'FREITAG   VENDREDI  VENERDI   '.
           02 FILLER PIC X(30) VALUE 'SAMSTAG   SAMEDI    SABATO    '.
           02 FILLER PIC X(30) VALUE 'SONNTAG   DIMANCHE  DOMENICA  '.
           02 FILLER PIC X(30) VALUE 'MONTAG    LUNDI     LUNEDI    '.
       01  WOTAB-REDEF  REDEFINES WOTAB.
           02 DAYS-3    OCCURS 7 TIMES.
              03 LANG-1 PIC X(10).
              03 LANG-2 PIC X(10).
              03 LANG-3 PIC X(10).
       01  TATAB.
REMOVE     02 FILLER       PIC S9999      VALUE 0.
      *  DC    H'31'
REMOVE     02 FILLER    PIC S9999      VALUE 31.
      *  DC    H'59'
REMOVE     02 FILLER    PIC S9999      VALUE 59.
      *  DC    H'90'
REMOVE     02 FILLER    PIC S9999      VALUE 90.
      *  DC    H'120'
REMOVE     02 FILLER    PIC S9999      VALUE 120.
      *  DC    H'151'
REMOVE     02 FILLER    PIC S9999      VALUE 151.
      *  DC    H'181'
REMOVE     02 FILLER    PIC S9999      VALUE 181.
      *  DC    H'212'
REMOVE     02 FILLER    PIC S9999      VALUE 212.
      *  DC    H'243'
REMOVE     02 FILLER    PIC S9999      VALUE 243.
      *  DC    H'273'
REMOVE     02 FILLER    PIC S9999      VALUE 273.
      *  DC    H'304'
REMOVE     02 FILLER    PIC S9999      VALUE 304.
      *  DC    H'334'
REMOVE     02 FILLER    PIC S9999      VALUE 334.
      *  DC    X'FF'
REMOVE     02 FILLER    PIC S9999      VALUE 336.
      *  DC    X'FF'
       01  TATAB-RED    REDEFINES TATAB.
REMOVE     02 TATAB-1   OCCURS 12 TIMES PIC S9999.
       01  WORK-DATA-2.
REMOVE     02 R1        PIC S9(8).
REMOVE     02 R9        PIC S9(8).
REMOVE     02 R8        PIC S9(8).
REMOVE     02 TAB-I     PIC S9(4).
REMOVE     02 W-I       PIC S9(4).
      *
       LINKAGE SECTION.
RENAME 01  PARAM-1.
RENAME     02 PARAM-1-TAG
RENAME                  PIC 99.
           02 FILLER    PIC X.
RENAME     02 PARAM-1-MONAT
RENAME                  PIC 99.
           02 FILLER    PIC X.
RENAME     02 PARAM-1-JAHRHUNDERT
RENAME                  PIC 99.
           02 FILLER    PIC X.
RENAME     02 PARAM-1-JAHR
RENAME                  PIC 99.
RENAME 01  PARAM-2.
           02 LANG-CODE PIC 9.
RENAME 01  PARAM-3.
           02 DIRECTION PIC X.
RENAME 01  PARAM-4.
           02 DAY-NAME  PIC X(10).
RENAME PROCEDURE DIVISION USING PARAM-1 PARAM-2 PARAM-3 PARAM-4.
REFINE X-START-LABEL.
RENAME     MOVE 19 TO PARAM-1-JAHRHUNDERT
RENAME     MOVE PARAM-1-TAG TO DD
RENAME     MOVE PARAM-1-MONAT TO MONTH
RENAME     MOVE PARAM-1-JAHR TO YEAR
RENAME     MOVE LANG-CODE TO SPRACHENCODE
      *  CALL  XM016,(DDMMYY,P16),VL
           MOVE DIRECTION TO LEFT-RIGHT-ALIGNMENT
           MOVE '0' TO P16
           CALL 'XM016' USING DDMMYY, P16
           IF P16 NOT = '0'
             MOVE ALL '?' TO DAY-NAME
             GOBACK
           END-IF.
      *                            DEFAULT WERT
RENAME     IF SPRACHENCODE = 1
RENAME     OR SPRACHENCODE = 2
RENAME     OR SPRACHENCODE = 3
RENAME       CONTINUE
RENAME     ELSE
      *                            DEFAULT WERT
             MOVE 1 TO SPRACHENCODE
           END-IF
           IF LEFT-RIGHT-ALIGNMENT = 'L'
           OR LEFT-RIGHT-ALIGNMENT = 'R'
             CONTINUE
           ELSE
             MOVE 'L' TO LEFT-RIGHT-ALIGNMENT
           END-IF
           MOVE DD TO DDP
           MOVE MONTH TO MMP
           MOVE YEAR TO YYP
           MOVE DDP TO DDB
      ***************************************************************
      *                            YEAR
      *                            MINUS 1
      *                            GET DAYS
      *                            SAVE IT
           MOVE MMP TO MMB
      ***************************************************************
      *
      *        KORREKTUR SCHALTJAHRE
      *
           MOVE YYP TO YYB
      *                            YEAR / 4
           COMPUTE YTT = ( YYB - 1 ) * 365
           MOVE YYB TO R9 R8
      *                            /     SCHALTJAHR
           COMPUTE R9 = R9 / 4
      *                            / MONTH > FEBR. OK
      *                            SUBTRACT 1
           COMPUTE R8 = R8 - 4 * R9
           IF R8 = 0 AND MMB <= 2
      *                            SAVE CORRECTION
             SUBTRACT 1 FROM R9
      ***************************************************************
      *
      *                            GET ADDR FOR DAYS
           END-IF
      *                            SAVE DAYS FROM PREVIOS MONTHS
           MOVE R9 TO STT
           MOVE MMB TO TAB-I
           IF TAB-I < 1 OR TAB-I > 12
             DISPLAY 'ERROR IN XM059, TATAB INDEX: ' TAB-I '  ERDOES'
             MOVE ALL 'X' TO DAY-NAME
             GOBACK
           END-IF
           MOVE TATAB-1 (TAB-I) TO MTT
           COMPUTE R9 = YTT + STT + MTT + DDB
           COMPUTE R1 = R9 / 7
           COMPUTE R8 = 7 * R1
           COMPUTE TAB-I = R9 - R8
           IF TAB-I = 0
             MOVE 7 TO TAB-I
           END-IF
           IF TAB-I < 1 OR TAB-I > 7
             DISPLAY 'ERROR IN XM059, WOTAB INDEX: ' TAB-I '  ERDOES'
             MOVE ALL 'X' TO DAY-NAME
      *                            MOVE WEEKDAY TO USER
             GOBACK
           END-IF
           EVALUATE TRUE
             WHEN SPRACHENCODE = 1
               MOVE LANG-1 (TAB-I) TO DAY-NAME
             WHEN SPRACHENCODE = 2
               MOVE LANG-2 (TAB-I) TO DAY-NAME
             WHEN SPRACHENCODE = 3
      *                            FOR LEFT SCHIFT
               MOVE LANG-3 (TAB-I) TO DAY-NAME
           END-EVALUATE
           IF LEFT-RIGHT-ALIGNMENT = 'L'
             CONTINUE
           ELSE
             MOVE DAY-NAME TO WW
             MOVE 10 TO TAB-I
             PERFORM WITH TEST BEFORE UNTIL W1 (TAB-I) NOT = SPACE
               SUBTRACT 1 FROM TAB-I
             END-PERFORM
             PERFORM WITH TEST BEFORE VARYING W-I FROM 10 BY -1
                                      UNTIL TAB-I = 0 OR TAB-I = 10
               MOVE W1 (TAB-I) TO W1 (W-I)
               MOVE SPACE TO W1 (TAB-I)
               SUBTRACT 1 FROM TAB-I
             END-PERFORM
             MOVE WW TO DAY-NAME
           END-IF.
           GOBACK.
