      ******************************************************************
      *                                                                *
      *   MONOLITIHIC, UNSTRUCTURED, UNREUSABLE, DIRTY COBOL PROGRAM   *
      *                                                                *
      ******************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. COBOLD.
      *AUTHOR.     H. SNEED.
      *DATE.       SEPT l993.
      /
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
IBMPC**     CONSOLE IS OUTPUT-DEV.
UNISYS*     PRINTER IS OUTPUT-DEV
UNISYS*     CARD-READER IS INPUT-STREAM.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *
           SELECT CUSTOMER-FILE
           ASSIGN TO "SYS015"
           RECORD KEY IS CUST-NO IN CUSTOMER-RECORD
           ORGANIZATION IS INDEXED
           ACCESS RANDOM.
      *
           SELECT ARTICLE-FILE
           ASSIGN TO "SYS016"
           RECORD KEY IS ART-NO IN ARTICLE-RECORD
           ORGANIZATION IS INDEXED
           ACCESS RANDOM.
      *
           SELECT ORDER-FILE
           ASSIGN TO "SYS017".
      *
           SELECT DISPATCH-FILE
           ASSIGN TO "SYS018".
      *
           SELECT OPEN-POSITIONS
           ASSIGN TO "SYS019".
      *
           SELECT CUSTOMER-REPORT
           ASSIGN TO "SYS020".
      ******************************************************************
      /
       DATA DIVISION.
       FILE SECTION.
      *
       FD  CUSTOMER-FILE
           LABEL RECORD STANDARD
           RECORDING MODE F
           DATA RECORD IS CUSTOMER-RECORD.
       01  CUSTOMER-RECORD.
           02  REC-TYPE                   PIC XX.
           02  CUST-NO                    PIC 9(8) COMP.
           02  CUST-NAME                  PIC X(20).
           02  CUST-ADDRESS.
               03  STR                    PIC X(30).
               03  ZIP                    PIC 9(4).
               03  CITY                   PIC X(20).
               03  STATE                  PIC X(4).
           02  CUST-CREDIT                PIC 9.
      ****************************************************************
       FD  ARTICLE-FILE
           LABEL RECORD STANDARD
           RECORDING MODE F
           DATA RECORD IS ARTICLE-RECORD.
       01  ARTICLE-RECORD.
           02  REC-TYPE                   PIC XX.
           02  ART-NO                     PIC 9(8) COMP.
           02  ART-TYPE                   PIC X(4).
           02  ART-QUAN                   PIC S9(5) USAGE COMP.
           02  ART-PRICE                  PIC S999V99 COMP-3.
           02  ART-NAME                   PIC X(40).
      ****************************************************************
       FD  ORDER-FILE
           LABEL RECORD STANDARD
           RECORDING MODE F
           DATA RECORD IS ORDER-RECORD.
       01  ORDER-RECORD.
           02  REC-TYPE                   PIC XX.
           02  ORDER-NO                   PIC 9(8) COMP.
           02  CUST-NO                    PIC 9(8) COMP.
           02  ORDER-ITEMS.
               03  ORDER-ITEM             OCCURS 9 TIMES.
                   04  ITEM-NO            PIC 9(3).
                   04  ART-NO             PIC 9(8) COMP.
                   04  ART-TYPE           PIC X(4).
                   04  ITEM-QUAN          PIC 9(5) USAGE COMP.
      ****************************************************************
       FD  DISPATCH-FILE
           LABEL RECORD STANDARD
           RECORDING MODE F
           DATA RECORD IS DISPATCH-RECORD.
       01  DISPATCH-RECORD.
           02  REC-TYPE                   PIC XX.
           02  ORDER-NO                   PIC 9(8) COMP.
           02  CUST-NO                    PIC 9(8) COMP.
           02  CUST-NAME                  PIC X(20).
           02  CUST-ADDRESS.
               03  STR                    PIC X(30).
               03  ZIP                    PIC 9(4).
               03  CITY                   PIC X(20).
               03  STATE                  PIC X(4).
           02  ORDER-ITEMS.
               03  DISPATCH-ITEM.
                   04  ITEM-NO            PIC 9(3).
                   04  ART-NO             PIC 9(8) COMP.
                   04  ART-TYPE           PIC 999.
                   04  ITEM-QUAN          PIC 9(5) USAGE COMP.
           02  PAYMENT                    PIC X.
      ****************************************************************
       FD  OPEN-POSITIONS
           LABEL RECORD STANDARD
           RECORDING MODE F
           DATA RECORD IS POSITION-RECORD.
       01  POSITION-RECORD.
           02  REC-TYPE                   PIC XX.
           02  ORDER-NO                   PIC 9(8) COMP.
           02  CUST-NO                    PIC 9(8) COMP.
           02  ORDER-ITEMS.
               03  DISPATCH-ITEM.
                   04  ITEM-NO            PIC 9(3).
                   04  ART-NO             PIC 9(8) COMP.
                   04  ART-TYPE           PIC 999.
                   04  ITEM-QUAN          PIC 9(5) USAGE COMP.
      ****************************************************************
       FD  CUSTOMER-REPORT
           LABEL RECORD STANDARD
           RECORDING MODE F
           DATA RECORD IS PRT-LINE.
       01  PRT-LINE                       PIC X(133).
      *
      /
       WORKING-STORAGE SECTION.
      ****************************************************************
      *
       77  ART-KEY                        PIC 9(8) COMP.
       77  CUST-KEY                       PIC 9(8) COMP.
       77  POS                            PIC 99 USAGE COMP.
       77  ERROR-TYPE                     PIC 99.
       77  PAGE-COUNT                     PIC 999 COMP VALUE 0.
       77  LINE-COUNT                     PIC 99 COMP VALUE 0.
       77  PRICE                          PIC 99999V99.
       77  TOTAL-CUST-PRICE               PIC 99999V99.
       77  TOTAL-ITEMS-FULFILLED          PIC 99 COMP VALUE 0.
      ****************************************************************
       01  HEADER-PRT-LINE.
           02  HEADER-LINE-CNTR           PIC X.
           02  ORDER-NO-TITLE             PIC X(14)
               VALUE " ORDER NUMBER ".
           02  CUST-NO-TITLE              PIC X(14)
               VALUE " CUSTOMER NO. ".
           02  CUST-NAME-TITLE            PIC X(20)
               VALUE "    CUSTOMER NAME   ".
           02  ART-NO-TITLE               PIC X(14)
               VALUE "ARTICLE NUMBER".
           02  ART-NAME-TITLE             PIC X(20)
               VALUE "     ARTICLE NAME   ".
           02  ART-QUAN-TITLE             PIC X(14)
               VALUE " ORDER AMOUNT ".
           02  ART-PRICE-TITLE            PIC X(14)
               VALUE " ARTICLE PRICE".
           02  TOTAL-PRICE-TITLE          PIC X(14)
               VALUE " TOTAL PRICE  ".
           02  PAGE-TITLE                 PIC X(7)
               VALUE " PAGE: ".
           02  PAGE-COUNT-NO              PIC 9999.
           02  FILLER                     PIC X(8).
      ****************************************************************
       01  UNDER-LINE.
           02 UNDER-LINE-CNTR             PIC X.
           02 FILLER                      PIC X(132)
              VALUE ALL "*".
      ****************************************************************
       01  DATA-PRT-LINE.
           02  DATA-LINE-CNTR             PIC X.
           02  FILLER                     PIC X(6).
           02  ORDER-NO                   PIC 9(8).
           02  FILLER                     PIC X(6).
           02  FILLER                     PIC X(6).
           02  CUST-NO                    PIC 9(8).
           02  FILLER                     PIC X(6).
           02  CUST-NAME                  PIC X(20).
           02  FILLER                     PIC X(6).
           02  ART-NO                     PIC 9(8).
           02  FILLER                     PIC X(6).
           02  ART-NAME                   PIC X(20).
           02  FILLER                     PIC X(6).
           02  ART-QUAN                   PIC 9(8).
           02  FILLER                     PIC X(6).
           02  FILLER                     PIC X(6).
           02  ART-PRICE                  PIC ZZZZ9.99.
           02  FILLER                     PIC X(6).
           02  TOTAL-PRICE                PIC ZZZZ9.99.
           02  FILLER                     PIC X(6).
      ****************************************************************
       01  ERROR-PRT-LINE.
           02  ERROR-LINE-CNTR            PIC X.
           02  FILLER                     PIC X(6).
           02  ERROR-MESSAGE              PIC X(40).
           02  FILLER                     PIC X(86).
      ****************************************************************
       01  SUMMARY-PRT-LINE.
           02  SUM-LINE-CNTR              PIC X.
           02  FILLER                     PIC X(6).
           02  FILLER                     PIC X(20).
           02  CUST-NO                    PIC 9(8).
           02  FILLER                     PIC X(6).
           02  CUST-NAME                  PIC X(20).
           02  ITEMS-ORDERED-TITLE        PIC X(15)
               VALUE " ITEMS ORDERED:".
           02  NO-ITEMS-ORDERED           PIC 99.
           02  ITEMS-FULFILLED-TITLE      PIC X(17)
               VALUE " ITEMS FULFILLED:".
           02  NO-ITEMS-FULFILLED         PIC 99.
           02  TOTAL-PRICE-TITLE          PIC X(13)
               VALUE " TOTAL PRICE:".
           02  TOTAL-PRICE-FOR-CUST       PIC ZZZZ9.99.
      /
      ****************************************************************
       PROCEDURE DIVISION.
      ****************************************************************
      * INITIALIZE ORDER ENTRY PROCESSING
       INITIALIZATION.
           OPEN INPUT  ORDER-FILE.
           OPEN INPUT  CUSTOMER-FILE.
           OPEN I-O    ARTICLE-FILE.
           OPEN OUTPUT DISPATCH-FILE.
           OPEN OUTPUT OPEN-POSITIONS.
           OPEN OUTPUT CUSTOMER-REPORT.
           MOVE 1 TO PAGE-COUNT.
           MOVE PAGE-COUNT TO PAGE-COUNT-NO.
           MOVE HEADER-PRT-LINE TO PRT-LINE.
           WRITE PRT-LINE AFTER ADVANCING PAGE.
      *
      ****************************************************************
      * READ ORDERS UNTIL END OF ORDER-FILE
       READ-ORDERS.
           READ ORDER-FILE
                AT END GO TO TERMINATION.
      ****************************************************************
      * READ CUSTOMER-DATA WITH KEY = CUST-NO
       READ-CUSTOMER.
      * ERROR CORRECTED, ERROR-TYPE INITIALIZED
           MOVE ZERO TO ERROR-TYPE.
           MOVE CUST-NO IN ORDER-RECORD TO CUST-KEY.
           READ CUSTOMER-FILE
                INVALID KEY MOVE 1 TO ERROR-TYPE
                            GO TO REPORT-ERROR.
           MOVE 0 TO POS.
           MOVE ZERO TO TOTAL-ITEMS-FULFILLED
           MOVE ZERO TO TOTAL-CUST-PRICE.
      ****************************************************************
      * PROCESS ORDER ITEMS FROM 1 TO 9
      * OR UNTIL ITEM-NO = 999
       PROCESS-ORDER.
      * ERROR CORRECTED, ERROR-TYPE INITIALIZED
           MOVE ZERO TO ERROR-TYPE.
           ADD 1 TO POS.
      * ERROR OCCURED HERE BY SKIPPING OVER LAST ORDER-ITEM **********
      * IF POS = 9 SHOULD BE IF POS > 9
      * IF ITEM-NO (POS) > 999 SHOULD BE ITEM-NO (POS) = 999
           IF POS > 9
           OR ITEM-NO IN ORDER-RECORD (POS) = 9
                      SUBTRACT 1 FROM POS
                      GO TO PRINT-SUMMARY.
      * ERROR OCCURED HERE BECAUSE POS IS 1 MORE THAN FINAL ITEM
      * READ ARTICLE DATA WITH KEY = ART-NO
           READ ARTICLE-FILE
                INVALID KEY MOVE 2 TO ERROR-TYPE
                            GO TO REPORT-ERROR.
      * CHECK IF QUANTITY IS SUFFICIENT AND DEDUCT ORDER FROM STOCK
           IF ITEM-QUAN IN ORDER-RECORD (POS) >
              ART-QUAN IN ARTICLE-RECORD
                          MOVE 3 TO ERROR-TYPE
                          GO TO WRITE-OPEN-POSITIONS
           ELSE
              SUBTRACT ITEM-QUAN IN ORDER-RECORD (POS) FROM
                       ART-QUAN IN ARTICLE-RECORD
              REWRITE ARTICLE-RECORD
                          GO TO WRITE-DISPATCH.
      ****************************************************************
      * WRITE OPEN POSITION
       WRITE-OPEN-POSITIONS.
           MOVE CUST-NO IN ORDER-RECORD TO CUST-NO IN POSITION-RECORD.
           MOVE ORDER-NO IN ORDER-RECORD TO ORDER-NO IN POSITION-RECORD.
           MOVE ORDER-ITEM IN ORDER-RECORD (POS) TO DISPATCH-ITEM
                                    IN POSITION-RECORD.
           MOVE "P " TO REC-TYPE IN POSITION-RECORD.
           WRITE POSITION-RECORD.
           GO TO REPORT-ORDER.
      ****************************************************************
      * WRITE DISPATCH RECORD FOR SHIPMENT
       WRITE-DISPATCH.
           ADD 1 TO TOTAL-ITEMS-FULFILLED.
           MOVE ORDER-NO IN ORDER-RECORD TO ORDER-NO IN DISPATCH-RECORD
           MOVE CUST-NO IN ORDER-RECORD TO CUST-NO IN DISPATCH-RECORD
           MOVE CUST-NAME IN CUSTOMER-RECORD TO CUST-NAME IN
                                             DISPATCH-RECORD.
           MOVE CUST-ADDRESS IN CUSTOMER-RECORD TO
                CUST-ADDRESS IN DISPATCH-RECORD.
           MOVE ORDER-ITEM IN ORDER-RECORD (POS) TO DISPATCH-ITEM
                                    IN DISPATCH-RECORD.
           IF CUST-CREDIT > 5
              MOVE "N" TO PAYMENT
           ELSE
              MOVE "C" TO PAYMENT.
           MOVE "D " TO REC-TYPE IN DISPATCH-RECORD.
           WRITE DISPATCH-RECORD.
      * PRINT OUT ORDER DATA WITH TOTALED PRICES
       REPORT-ORDER.
           IF ERROR-TYPE > 0
              GO TO REPORT-ERROR.
           MOVE SPACES TO DATA-PRT-LINE.
           MOVE CUST-NO IN CUSTOMER-RECORD TO CUST-NO IN DATA-PRT-LINE.
           MOVE CUST-NAME IN CUSTOMER-RECORD TO CUST-NAME IN
                                                     DATA-PRT-LINE.
           MOVE ART-NO IN ARTICLE-RECORD TO ART-NO IN DATA-PRT-LINE.
           MOVE ART-NAME IN ARTICLE-RECORD TO ART-NAME IN
                                                      DATA-PRT-LINE.
           MOVE ITEM-QUAN IN ORDER-RECORD (POS) TO
                             ART-QUAN IN DATA-PRT-LINE.
           MOVE ART-PRICE IN ARTICLE-RECORD TO
                ART-PRICE IN DATA-PRT-LINE.
           MULTIPLY ART-PRICE IN ARTICLE-RECORD BY ITEM-QUAN
                    IN ORDER-RECORD (POS) GIVING PRICE.
           MOVE PRICE TO TOTAL-PRICE.
           ADD PRICE TO TOTAL-CUST-PRICE.
           MOVE DATA-PRT-LINE TO PRT-LINE.
           WRITE PRT-LINE AFTER ADVANCING 2 LINES.
           ADD 2 TO LINE-COUNT.
           IF LINE-COUNT > 50
              ADD 1 TO PAGE-COUNT
              MOVE PAGE-COUNT TO PAGE-COUNT-NO
              MOVE HEADER-PRT-LINE TO PRT-LINE
              WRITE PRT-LINE AFTER ADVANCING PAGE-COUNT
              MOVE UNDER-LINE TO PRT-LINE
              WRITE PRT-LINE AFTER ADVANCING 1 LINES
              MOVE 0 TO LINE-COUNT.
           GO TO PROCESS-ORDER.
      * PRINT ERROR MESSAGE
       REPORT-ERROR.
           MOVE SPACES TO DATA-PRT-LINE.
           MOVE SPACES TO ERROR-PRT-LINE.
           MOVE ORDER-NO IN ORDER-RECORD TO ORDER-NO IN DATA-PRT-LINE.
           MOVE CUST-NO IN ORDER-RECORD TO CUST-NO IN DATA-PRT-LINE.
           IF ERROR-TYPE > 1
               MOVE ART-NO IN ORDER-RECORD (POS) TO
                    ART-NO IN DATA-PRT-LINE
               IF ERROR-TYPE > 2
                  MOVE ART-NAME IN ARTICLE-RECORD TO
                       ART-NAME IN DATA-PRT-LINE
                  MOVE ART-QUAN IN ARTICLE-RECORD TO
                       ART-QUAN IN DATA-PRT-LINE.
           MOVE DATA-PRT-LINE TO PRT-LINE.
           WRITE PRT-LINE AFTER ADVANCING 2 LINES.
           IF ERROR-TYPE = 1
               MOVE "CUSTOMER NOT KNOWN " TO ERROR-MESSAGE.
           IF ERROR-TYPE = 2
               MOVE "ARTICLE NOT AVAILABLE " TO ERROR-MESSAGE.
           MOVE ERROR-PRT-LINE TO PRT-LINE.
      * ERROR OCCURED HERE BECAUSE DATA-PRT-LINE INSTEAD OFF ERROR
           WRITE PRT-LINE AFTER ADVANCING 2 LINES.
           IF ERROR-TYPE = 3
               MOVE "INSUFFICIENT QUANTITY ON STOCK" TO ERROR-MESSAGE.
           MOVE ERROR-PRT-LINE TO PRT-LINE.
           WRITE PRT-LINE AFTER ADVANCING 1 LINES.
           ADD 1 TO LINE-COUNT.
           IF LINE-COUNT > 50
               ADD 1 TO PAGE-COUNT
               MOVE PAGE-COUNT TO PAGE-COUNT-NO
               MOVE HEADER-PRT-LINE TO PRT-LINE
               WRITE PRT-LINE AFTER ADVANCING PAGE
               MOVE UNDER-LINE TO PRT-LINE
               WRITE PRT-LINE AFTER ADVANCING 1 LINES
               MOVE 0 TO LINE-COUNT.
           IF ERROR-TYPE > 1
               GO TO PROCESS-ORDER
           ELSE
               GO TO READ-ORDERS.
      * PRINT CUSTOMER SUMMARY
       PRINT-SUMMARY.
           MOVE CUST-NO IN CUSTOMER-RECORD TO CUST-NO IN
               SUMMARY-PRT-LINE.
           MOVE CUST-NAME IN CUSTOMER-RECORD TO CUST-NAME IN
               SUMMARY-PRT-LINE.
           MOVE POS TO NO-ITEMS-ORDERED.
           MOVE TOTAL-ITEMS-FULFILLED TO NO-ITEMS-FULFILLED.
           MOVE TOTAL-CUST-PRICE TO TOTAL-PRICE-FOR-CUST.
           MOVE SUMMARY-PRT-LINE TO PRT-LINE.
           WRITE PRT-LINE AFTER ADVANCING 3 LINES
           ADD 3 TO LINE-COUNT.
           IF LINE-COUNT > 50
               ADD 1 TO PAGE-COUNT
               MOVE PAGE-COUNT TO PAGE-COUNT-NO
               MOVE HEADER-PRT-LINE TO PRT-LINE
               WRITE PRT-LINE AFTER ADVANCING PAGE
               MOVE UNDER-LINE TO PRT-LINE
               WRITE PRT-LINE AFTER ADVANCING 1 LINES
               MOVE 0 TO LINE-COUNT.
           GO TO READ-ORDERS.
      ****************************************************************
      * TERMINATE ORDER ENTRY PROCESSING
       TERMINATION.
           DISPLAY "ORDER ENTRY PROCESSING COMPLETED".
           CLOSE ORDER-FILE.
           CLOSE CUSTOMER-FILE.
           CLOSE ARTICLE-FILE.
           CLOSE DISPATCH-FILE.
           CLOSE OPEN-POSITIONS.
           CLOSE CUSTOMER-REPORT.
           STOP RUN.
      ********************** end of source *****************************
