      $SET ANS85
       IDENTIFICATION DIVISION.
       PROGRAM-ID. RECHNUNG.
      ******************************************************************
      *  PROGRAM NAME: RECHNUNG                                        *
      *  SYSTEM  NAME: AUFTRAG = AUFTRAGBEARBEITUNG                    *
      *  PURPOSE:      subprogram for producing the invoice            *
      *  VERSION:      1.1 (07.96)                                     *
      *  LANGUAGE:     MICROSOFT (R) COBOL OPTIMIZIG COMPILER          *
      *                VERSION 3.00A ("MICROFOCUS COBOL")              *
      ******************************************************************
      *  PROGRAM FUNCTIONS:                                            *
      *    - init Rechnungen                                           *
      *    - open Rechnungsposten                                      *
      *    - Do for each Rechnungsposten                               *
      *      - If neuer Kunde                                          *
      *        - write Rechnungsfuss                                   *
      *      - If Kundenende                                           *
      *        - write Rechnungskopf                                   *
      *      - write Rechnungsposten                                   *
      *    - Enddo                                                     *
      *    - close Rechnungen                                          *
      ******************************************************************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-PC.
       OBJECT-COMPUTER. IBM-PC.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *   Datei der Rechnungsposten
          SELECT BILLING-FILE ASSIGN TO INPUT-FILE
                 ORGANIZATION IS LINE SEQUENTIAL.
      *   Liste der Rechnungen
          SELECT RECHNUNGSDATEI ASSIGN TO 'Outputs\BILLING.txt'
                 ORGANIZATION IS LINE SEQUENTIAL.
      ******************************************************************
      *
       DATA DIVISION.
      *
      ******************************************************************
      *
       FILE SECTION.
      *
      ******************************************************************
      *
      *   Datei der Rechnungsposten
       FD  BILLING-FILE
           DATA RECORDS IS BILLING-ITEM.
      *   Billing Item from XML File
WRAP   01  BILLING-ITEM-REC    PIC X(80).
WRAP  * ****  Record removed ****
       FD  RECHNUNGSDATEI
           DATA RECORD IS RECHNUNGSSATZ.
       01  RECHNUNGSSATZ.
           05  RECHNUNGSZEILE                PIC X(72).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
      ******************************************************************
      *
       77  DB-DIRECTORY                      PIC X(40) VALUE
           'DataBase'.
       77  INPUT-FILE                        PIC X(80).
       77  BILLING-STATUS                    PIC XX.
           88  OK-BILLING                    VALUE ZERO.
           88  EOF-BILLING                   VALUE '09'.
       77  CONTINUE-KEY                      PIC XX.
      ****************************************************************
      *
       01  DB-INTERFACE.
           05  DB-TABLE-NAME              PIC X(8).
           05  DB-OPERATION               PIC X(8).
           05  DB-SEARCH-KEY              PIC 9(6).
           05  DB-RECORD                  PIC X(92).
           05  DB-RETURN-CODE             PIC 99.
      *
      ****************************************************************
      *
       01  CUSTOMER-RECORD.
           02  CUST-REC-TYPE              PIC XX VALUE 'CU'.
           02  FILLER                     PIC X.
           02  CUST-NO                    PIC 9(6).
           02  FILLER                     PIC X.
           02  CUST-NAME                  PIC X(20).
           02  FILLER                     PIC X.
             02  CUST-CREDIT              PIC 99.
           02  FILLER                     PIC X.
           02  CUST-ADDRESS.
               03  CUST-STREET            PIC X(20).
               03  FILLER                 PIC X.
               03  CUST-ZIP               PIC 9(4).
               03  FILLER                 PIC X.
               03  CUST-CITY              PIC X(20).
               03  FILLER                 PIC X.
               03  CUST-STATE             PIC X(4).
      *
      ******************************************************************
      *
       01  LISTENKONSTANTEN.
           05  ZEILEN-MAX                    PIC 99  VALUE 72.
           05  SEITEN-MAX                    PIC 99  VALUE 99.
       01  LISTENVARIABELN.
           05  TAGESDATUM.
               10  JAHR                      PIC 99.
               10  MONAT                     PIC 99.
               10  TAG                       PIC 99.
           05  LISTENDATUM.
               10  LISTENTAG                 PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENMONAT               PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENJAHR                PIC 99.
           05  SEITENNR                      PIC 999 VALUE 1.
           05  ZEILENANZAHL                  PIC 99  VALUE 73.
           05  LAST-ORDER-NO                 PIC 9(6) VALUE ZEROES.
           05  LAST-CUST-NO                  PIC 9(6) VALUE ZEROES.
      ******************************************************************
      *
       01  RECHNUNGSKONSTANTEN.
           05  ZAHLUNGSMODUS-1               PIC X(30) VALUE
              'Zahlung durch Ueberweisung'.
           05  ZAHLUNGSMODUS-2               PIC X(30) VALUE
              'Zahlung durch Scheck      '.
           05  ZAHLUNGSMODUS-3               PIC X(30) VALUE
              'Zahlung durch Bar         '.
           05  ZAHLUNGSMODUS-4               PIC X(30) VALUE
              'Zahlung im Voraus         '.
           05  RECHNUNGSPROGRAM              PIC X(10) VALUE 'Billing'.
           05  MWST-SATZ                     PIC 9V99    VALUE 0.16.
       01  RECHNUNGSKOPF.
           05  KOPFZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  KOPFZEILE-2.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(70) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-3.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'TITEL:  '.
               10  KOPFZEILE-TITEL           PIC X(42).
               10  FILLER                    PIC X(8) VALUE 'SEITE:  '.
               10  KOPFZEILE-SEITE           PIC 9(4).
               10  FILLER                    PIC X(6) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-4.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'QUELLE: '.
               10  KOPFZEILE-PROGRAM         PIC X(42).
               10  KOPFZEILE-4-4             PIC X(8) VALUE 'DATUM:  '.
               10  KOPFZEILE-DATUM           PIC X(8).
               10  FILLER                    PIC X(2) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  TITELZEILE-7                  PIC X(72).
           05  TITELZEILE-8.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-2                   PIC X(72).
           05  FUSSZEILE-3                   PIC X(72).
           05  FUSSZEILE-4                   PIC X(72).
       01  RECHNUNGSVARIABELN.
           05  RECH-NR                       PIC 9(4) VALUE ZERO.
           05  RECH-POSTEN-NR                PIC 99 VALUE ZERO.
           05  MWST                          PIC 9999V99.
           05  GESAMTBETRAG                  PIC 999999V99.
SNEED      05  THAT-PRICE                    PIC 9999V99.
SNEED      05  THIS-PRICE REDEFINES THAT-PRICE.
SNEED          10  THIS-PRICE-WHOLE          PIC 9999.
SNEED          10  THIS-PRICE-FRACT          PIC 9999.
           05  RECHENWERTE.
               10  STUECKPREIS               PIC 9999V99 VALUE ZERO.
               10  GESAMTPREIS               PIC 99999V99 VALUE ZERO.
               10  RECHNUNGSBETRAG           PIC 9999999V99 VALUE ZERO.
               10  RECHNUNGSANZAHL           PIC 999 VALUE ZERO.
               10  BESTELLUNGEN              PIC 999 VALUE ZERO.
               10  GESAMT-RECHNUNGSBETRAG    PIC 9999999V99 VALUE ZERO.
       01  RECHNUNGSTITEL.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(70) VALUE
           '  Rechnung der Universitt Regensburg              '.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Rechnungsnr:  '.
           05  RECHNUNGSKOPF-RECHNR          PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Auftragsnr: '.
           05  RECHNUNGSKOPF-AUFTRAGNR       PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Kundenkz:   '.
           05  RECHNUNGSKOPF-KUNDENKZ        PIC ZZZZZZ99.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-2.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(6)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Kundenname:   '.
           05  RECHNUNGSKOPF-KUNDENNAME      PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-3.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Kundenanschrift:  '.
           05  RECHNUNGSKOPF-STRASSE         PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-4.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE SPACES.
           05  RECHNUNGSKOPF-PLZ             PIC X(6).
           05  RECHNUNGSKOPF-ORT             PIC X(30).
           05  RECHNUNGSKOPF-LAND            PIC X(4).
           05  FILLER                        PIC X(10) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-5.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Zahlungsmodus:    '.
           05  RECHNUNGSKOPF-ZAHLUNGSMODUS   PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSPOSTENTITEL.
           05  FILLER                        PIC X    VALUE '|'.
           05  FILLER                        PIC X(9) VALUE 'Bestellnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(9) VALUE 'Artikelnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(20) VALUE
              ' Artikelbezeichnung '.
           05  FILLER                        PIC X(7) VALUE SPACES.
           05  FILLER                        PIC X(5) VALUE 'Menge'.
           05  FILLER                        PIC XX   VALUE SPACES.
           05  FILLER                        PIC X(5) VALUE 'Preis'.
           05  FILLER                        PIC XXX  VALUE SPACES.
           05  FILLER                        PIC X(5) VALUE 'Summe'.
           05  FILLER                        PIC XXX  VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSPOSTENZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  RECHNUNGSZEILE-BESTELLNR      PIC X(6).
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-ARTIKELNR      PIC X(6).
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-ARTIKELNAME    PIC X(27).
           05  RECHNUNGSZEILE-BESTELLMENGE   PIC ZZZZ99.
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-STUECKPREIS    PIC ZZZ9.99.
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-GESAMTPREIS    PIC ZZZ9.99.
           05  FILLER                        PIC X    VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSFUSS-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Rechnungszahl:'.
           05  RECHNUNGSFUSS-RECHNUNGEN      PIC ZZZ9.
           05  FILLER                        PIC X     VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Bestellungsanzahl:'.
           05  RECHNUNGSFUSS-BESTELLUNGEN    PIC ZZZ9.
           05  FILLER                        PIC X     VALUE SPACES.
           05  FILLER                        PIC X(16) VALUE
                                            'Rechnungsbetrag:'.
           05  RECHNUNGSFUSS-GESAMTBETRAG    PIC ZZ,ZZ9.99.
           05  FILLER                        PIC X     VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSFUSS-2.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(20) VALUE
                                            'Mehrwertsteuersatz: '.
           05  RECHNUNGSFUSS-MWST-SATZ       PIC Z.99.
           05  FILLER                        PIC X     VALUE '%'.
           05  FILLER                        PIC X(17) VALUE SPACES.
           05  FILLER                        PIC X(16) VALUE
                                            'Mehrwertsteuer: '.
           05  RECHNUNGSFUSS-MWST            PIC ZZ,ZZ9.99.
           05  FILLER                        PIC X     VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSFUSS-3.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(52) VALUE
               'Folgender Betrag ist innerhalb 30 Tage zu bezahlen: '.
           05  FILLER                        PIC X(5)  VALUE SPACES.
           05  RECHNUNGSFUSS-GESAMT          PIC ZZZ,ZZ9.99.
           05  FILLER                        PIC X     VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FEHLERMELDUNG                 PIC X(70).
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERMELDUNGEN.
           05  FM-1                          PIC X(50) VALUE
              '   Rechnungsdaten sind fehlerhaft               '.
           05  FM-2                          PIC X(50) VALUE
              '   Anzahl Rechnungsposten stimmt nicht ueberein '.
           05  FM-3                          PIC X(50) VALUE
              '   Rechnung muss per Hand erstellt werden       '.
      ****************************************************************
      *  Parameters from calling interface
      *
       01  CMD-LINE                          PIC X(80).
       01  RESULT                            PIC X  COMP-X.
       01  FUNCT                             PIC X  COMP-X VALUE 35.
       01  CMD-LINED.
           05  CMD-LINE-LNG                  PIC X  COMP-X VALUE ZERO.
      ************************************************************
      ************************************************************
WRAP       COPY INVOICES.cpy.
WRAP  *************** COBWRAP parameters ******************************
WRAP  *  Parameters for COBOL Programs
WRAP   01 X-COBOL-PARAMS.
WRAP      05  X-REC-LNG                PIC 9(8) USAGE BINARY.
WRAP      05  X-MAP-LNG                PIC 9(8) USAGE BINARY.
WRAP      05  X-ACCEPT-LNG             PIC 9999.
WRAP      05  X-DISPLAY-LNG            PIC 9999.
WRAP      05  X-ACCEPT-TEXT            PIC X(80).
WRAP      05  X-DISPLAY-TEXT           PIC X(80).
WRAP  *****************************************************************
WRAP  *  Parameters for data exchange between Program & Wrapper
WRAP  *
WRAP   01 X-PARAMS.
WRAP      05  X-FUNCODE                PIC XX.
WRAP      05  X-RETCODE                PIC 99.
WRAP      05  X-FILNAME                PIC X(80).
WRAP      05  X-METHOD                 PIC X(30).
********************  End COBWRAP Parameters *************************
       PROCEDURE DIVISION.
      *****************************************************
       RECHNUNGSSTEUERUNG SECTION.
      *****************************************************
       INIT-RECHNUNG.
           ACCEPT CMD-LINE FROM COMMAND-LINE.
           MOVE CMD-LINE TO INPUT-FILE
           DISPLAY 'Input Params = ' INPUT-FILE
TEST***    ACCEPT CONTINUE-KEY
           MOVE 'Auftragsrechnung ' TO KOPFZEILE-TITEL.
           MOVE 'Auftragsbearbeitung ' TO KOPFZEILE-PROGRAM.
           MOVE RECHNUNGSTITEL TO TITELZEILE-7.
           PERFORM OPEN-LISTE.
           EXIT.
      *****************************************************
       OPEN-RECHNUNGSPOSTEN.
           MOVE ZEROES TO BILLING-STATUS.
WRAP  *    OPEN INPUT BILLING-FILE.
           IF BILLING-STATUS NOT = ZEROES
              DISPLAY 'BILLING-FILE not found'
              DISPLAY 'Billing File Name = ' INPUT-FILE
              DISPLAY 'Press Enter to terminate !'
              ACCEPT  CONTINUE-KEY
              GOBACK
           END-IF.
      *****************************************************
       READ-RECHNUNGSPOSTEN.
           MOVE ZEROES TO BILLING-STATUS.
           PERFORM UNTIL EOF-BILLING
WRAP  *       READ BILLING-FILE
WRAP  *       AT END
WRAP       MOVE 'RD' TO X-FUNCODE
WRAP       MOVE ZEROES TO X-RETCODE
NEW        MOVE INPUT-FILE TO X-FILNAME
WRAP       MOVE 'BILLING-FILE' TO X-METHOD
WRAP       MOVE 88 TO X-REC-LNG
WRAP       CALL 'INVOICES' USING X-FUNCODE, X-RETCODE,
WRAP                             X-FILNAME, X-METHOD,
WRAP                             X-REC-LNG, BILLING-ITEM
WRAP       IF X-RETCODE NOT = ZEROES
                  MOVE '09' TO BILLING-STATUS
              ELSE
                  IF BILL-REC-TYPE = 'BI'
                     IF BILL-CUST-NO NOT = LAST-CUST-NO
                        IF LAST-CUST-NO NOT = ZEROES
                           PERFORM DRUCKE-RECHNUNGSFUSS
                        END-IF
                        PERFORM DRUCKE-RECHNUNGSKOPF
                     END-IF
TEST                 DISPLAY 'Billing Item read: ' BILLING-ITEM (1:60)
TEST                 DISPLAY 'Press Enter to process!'
TEST                 ACCEPT CONTINUE-KEY
                     PERFORM DRUCKE-RECHNUNGSPOSTEN
                  ELSE
                     DISPLAY 'Ungltige Rechnungssatzart=' BILL-REC-TYPE
TEST***              DISPLAY 'Press Enter to acknowledge!'
TEST***              ACCEPT  CONTINUE-KEY
                  END-IF
WRAP       END-IF
              MOVE BILL-ORDER-NO TO LAST-ORDER-NO
              MOVE BILL-CUST-NO  TO LAST-CUST-NO
           END-PERFORM.
           EXIT.
      *****************************************************
       CLOSE-RECHNUNGSPOSTEN.
           PERFORM DRUCKE-RECHNUNGSFUSS
WRAP  *    CLOSE BILLING-FILE.
           GOBACK.
      *****************************************************************
      *****************************************************************
       RECHNUNGSAUSGABE   SECTION.
      *****************************************************
       DRUCKE-RECHNUNGSKOPF.
           PERFORM HOLE-KUNDENSATZ
           ADD  1 TO RECH-NR
           MOVE RECH-NR TO RECHNUNGSKOPF-RECHNR
           MOVE BILL-ORDER-NO TO RECHNUNGSKOPF-AUFTRAGNR
           MOVE BILL-CUST-NO  TO RECHNUNGSKOPF-KUNDENKZ
           MOVE CUST-NAME     TO  RECHNUNGSKOPF-KUNDENNAME
           MOVE CUST-ZIP      TO  RECHNUNGSKOPF-PLZ
           MOVE CUST-CITY     TO  RECHNUNGSKOPF-ORT
           MOVE CUST-STREET   TO  RECHNUNGSKOPF-STRASSE
           MOVE CUST-STATE    TO  RECHNUNGSKOPF-LAND
           EVALUATE BILL-PAYMENT-MODE
               WHEN 'TRAN'
                   MOVE ZAHLUNGSMODUS-1 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
               WHEN 'CHEC'
                   MOVE ZAHLUNGSMODUS-2 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
               WHEN 'CASH'
                   MOVE ZAHLUNGSMODUS-3 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
               WHEN OTHER
                   MOVE ZAHLUNGSMODUS-4 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
           END-EVALUATE
           PERFORM PRINT-HEADER
           MOVE ZEROES TO RECHENWERTE
           MOVE ZERO TO RECH-POSTEN-NR.
      *****************************************************
       DRUCKE-RECHNUNGSPOSTEN.
           ADD 1 TO RECH-POSTEN-NR
           MOVE BILL-ITEM-NO   TO RECHNUNGSZEILE-BESTELLNR
           MOVE BILL-ART-NO    TO RECHNUNGSZEILE-ARTIKELNR
           MOVE BILL-ART-NAME  TO RECHNUNGSZEILE-ARTIKELNAME
           MOVE BILL-ART-PRICE TO STUECKPREIS
SNEED      MOVE STUECKPREIS (1:4) TO THIS-PRICE-WHOLE.
SNEED      MOVE STUECKPREIS (5:2) TO THIS-PRICE-FRACT.
           MOVE THAT-PRICE TO RECHNUNGSZEILE-STUECKPREIS
           MOVE BILL-ART-AMOUNT TO RECHNUNGSZEILE-BESTELLMENGE
           COMPUTE GESAMTPREIS = BILL-ART-AMOUNT
                               * THAT-PRICE
           MOVE GESAMTPREIS TO RECHNUNGSZEILE-GESAMTPREIS
           ADD  GESAMTPREIS TO RECHNUNGSBETRAG
           MOVE RECHNUNGSPOSTENZEILE TO RECHNUNGSZEILE
           PERFORM PRINT-LINE
           EXIT.
      *****************************************************
       DRUCKE-RECHNUNGSFUSS.
           ADD 1 TO RECHNUNGSANZAHL
           ADD RECH-POSTEN-NR TO BESTELLUNGEN
           ADD RECHNUNGSBETRAG TO GESAMT-RECHNUNGSBETRAG
           MOVE RECHNUNGSANZAHL TO RECHNUNGSFUSS-RECHNUNGEN
           MOVE BESTELLUNGEN    TO RECHNUNGSFUSS-BESTELLUNGEN
           MOVE GESAMT-RECHNUNGSBETRAG TO RECHNUNGSFUSS-GESAMTBETRAG
           MOVE MWST-SATZ TO RECHNUNGSFUSS-MWST-SATZ
           COMPUTE MWST = RECHNUNGSBETRAG * MWST-SATZ
           MOVE MWST TO RECHNUNGSFUSS-MWST
           COMPUTE GESAMTBETRAG = RECHNUNGSBETRAG + MWST
           MOVE GESAMTBETRAG TO RECHNUNGSFUSS-GESAMT
           MOVE RECHNUNGSFUSS-1 TO FUSSZEILE-2
           MOVE RECHNUNGSFUSS-2 TO FUSSZEILE-3
           MOVE RECHNUNGSFUSS-3 TO FUSSZEILE-4
           PERFORM PRINT-FOOTING
           PERFORM PAGE-CHANGE.
           EXIT.
      *****************************************************************
      *****************************************************************
       SUBROUTINES SECTION.
      *****************************************************
       OPEN-LISTE.
           OPEN OUTPUT RECHNUNGSDATEI.
           ACCEPT TAGESDATUM FROM DATE.
           MOVE TAG TO LISTENTAG.
           MOVE MONAT TO LISTENMONAT.
           MOVE JAHR TO LISTENJAHR.
           MOVE LISTENDATUM TO KOPFZEILE-DATUM.
           MOVE SEITENNR TO KOPFZEILE-SEITE.
           MOVE RECHNUNGSPROGRAM TO KOPFZEILE-PROGRAM
           MOVE RECHNUNGSTITEL TO TITELZEILE-7
           EXIT.
      *****************************************************
       PRINT-HEADER.
           MOVE SEITENNR TO KOPFZEILE-SEITE
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-2
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-3
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-4
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-2
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           WRITE RECHNUNGSSATZ FROM TITELZEILE-7
           WRITE RECHNUNGSSATZ FROM TITELZEILE-8
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-1
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-2
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-3
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-4
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-5
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           WRITE RECHNUNGSSATZ FROM RECHNUNGSPOSTENTITEL
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           MOVE 16 TO ZEILENANZAHL
           ADD 1 TO SEITENNR.
           EXIT.
      *****************************************************
       PRINT-LINE.
           MOVE RECHNUNGSPOSTENZEILE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSSATZ.
           ADD 1 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PRINT-FOOTING.
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-1
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-2
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-3
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-4
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-1
           ADD 5 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PAGE-CHANGE.
           MOVE SPACES TO RECHNUNGSSATZ
           MOVE  '/' TO RECHNUNGSSATZ
           WRITE RECHNUNGSSATZ AFTER PAGE.
           EXIT.
      *****************************************************
       HOLE-KUNDENSATZ.
           MOVE 'CUSTOMER' TO DB-TABLE-NAME
           MOVE 'SELECT '  TO DB-OPERATION
           MOVE SPACES     TO DB-RECORD
           MOVE BILL-CUST-NO TO DB-SEARCH-KEY
           CALL 'CUSTOMER' USING DB-INTERFACE, DB-DIRECTORY
           MOVE DB-RECORD TO CUSTOMER-RECORD
           IF DB-RETURN-CODE NOT = ZERO
              DISPLAY 'Customer ' BILL-CUST-NO ' could not be found!'
              DISPLAY 'Press Enter to terminate!'
              ACCEPT CONTINUE-KEY
              GOBACK
           END-IF.
           EXIT.
      * end of source
      ******************************************************************
