      $SET ANS85
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VERSAND.
      ******************************************************************
      *  PROGRAM NAME: VERSAND                                         *
      *  SYSTEM  NAME: AUFTRAG = AUFTRAGBEARBEITUNG                    *
      *  PURPOSE:      subprogram for producing the dispath notices    *
      *  VERSION:      1.1 (07.96)                                     *
      *  LANGUAGE:     MICROSOFT (R) COBOL OPTIMIZIG COMPILER          *
      *                VERSION 3.00A ("MICROFOCUS COBOL")              *
      *  PROGRAM FUNCTIONS:                                            *
      ******************************************************************
      *    - init  Versandauftraege                                    *
      *    - open  Versandposten                                       *
      *    - Do for each Versandposten                                 *
      *      - read Versandposten                                      *
      *      - if Kundenende                                           *
      *           - write Versandfuss                                  *
      *      - if neuer Kunde                                          *
      *           - write Versandkopf                                  *
      *      - write Versandposten                                     *
      *    - Enddo                                                     *
      *    - close Versandposten                                       *
      *    - close Versandauftraege                                    *
      ******************************************************************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-PC.
       OBJECT-COMPUTER. IBM-PC.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *   Datei der Versandposten
          SELECT DISPATCH-FILE ASSIGN TO INPUT-FILE
                 ORGANIZATION IS LINE SEQUENTIAL.
      *   Liste der Versandauftraege
          SELECT VERSANDDATEI ASSIGN TO 'Outputs\VERSAND.txt'
                 ORGANIZATION IS LINE SEQUENTIAL.
      ******************************************************************
      *
       DATA DIVISION.
      *
      ******************************************************************
      *
       FILE SECTION.
      *
      ******************************************************************
      *
      *   Datei der Versandposten
       FD  DISPATCH-FILE
           DATA RECORD IS DISPATCH-ORDER.
      ******************************************************************
      *
WRAP   01  DISPATCH-ORDER-REC    PIC X(80).
WRAP  * ****  Record removed ****
       FD  VERSANDDATEI
           DATA RECORD IS VERSANDSATZ.
       01  VERSANDSATZ.
           05  VERSANDZEILE                  PIC X(72).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
      ******************************************************************
      *
       77  INPUT-FILE                        PIC X(80).
       77  DISPATCH-STATUS                   PIC XX.
           88  OK-DISPATCH                   VALUE ZERO.
           88  EOF-DISPATCH                  VALUE '09'.
       77  CONTINUE-KEY                      PIC XX.
       01  LISTENKONSTANTEN.
           05  ZEILEN-MAX                    PIC 99  VALUE 72.
           05  SEITEN-MAX                    PIC 99  VALUE 99.
       01  LISTENVARIABELN.
           05  TAGESDATUM.
               10  JAHR                      PIC 99.
               10  MONAT                     PIC 99.
               10  TAG                       PIC 99.
           05  LISTENDATUM.
               10  LISTENTAG                 PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENMONAT               PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENJAHR                PIC 99.
           05  SEITENNR                      PIC 999 VALUE 1.
           05  ZEILENANZAHL                  PIC 99  VALUE 73.
           05  LAST-ORDER-NO                 PIC 9(6) VALUE ZEROES.
           05  LAST-CUST-NO                  PIC 9(6) VALUE ZEROES.
       01  VERSANDKONSTANTEN.
           05  VERSANDMODUS-1                PIC X(30) VALUE
              'Lufttransport             '.
           05  VERSANDMODUS-2                PIC X(30) VALUE
              'Bahntransport             '.
           05  VERSANDMODUS-3                PIC X(30) VALUE
              'Schifftransport           '.
           05  VERSANDMODUS-4                PIC X(30) VALUE
              'LKW-Transport             '.
           05  VERSANDPROGRAM              PIC X(10) VALUE 'Versand '.
       01  VERSANDKOPF.
           05  KOPFZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  KOPFZEILE-2.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(70) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-3.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'TITEL:  '.
               10  KOPFZEILE-TITEL           PIC X(42).
               10  FILLER                    PIC X(8) VALUE 'SEITE:  '.
               10  KOPFZEILE-SEITE           PIC 9(4).
               10  FILLER                    PIC X(6) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-4.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'QUELLE: '.
               10  KOPFZEILE-PROGRAM         PIC X(42).
               10  KOPFZEILE-4-4             PIC X(8) VALUE 'DATUM:  '.
               10  KOPFZEILE-DATUM           PIC X(8).
               10  FILLER                    PIC X(2) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  TITELZEILE-7                  PIC X(72).
           05  TITELZEILE-8.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-2                   PIC X(72).
           05  FUSSZEILE-3                   PIC X(72).
           05  FUSSZEILE-4                   PIC X(72).
       01  VERSANDVARIABELN.
           05  GESAMTMENGE                   PIC 9(5) VALUE ZERO.
           05  VERSAND-NR                    PIC 9(4) VALUE ZERO.
           05  VERSAND-POSTEN-NR             PIC 99 VALUE ZERO.
       01  VERSANDTITEL.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(70) VALUE
           '  Versandauftrag der Universitt Regensburg        '.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Versandauftnr:'.
           05  VERSANDKOPF-RECHNR            PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Auftragsnr: '.
           05  VERSANDKOPF-AUFTRAGNR         PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Kundenkz:   '.
           05  VERSANDKOPF-KUNDENKZ          PIC ZZZZZZ99.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-2.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(6)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Kundenname:   '.
           05  VERSANDKOPF-KUNDENNAME        PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-3.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Kundenanschrift:  '.
           05  VERSANDKOPF-STRASSE           PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-4.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE SPACES.
           05  VERSANDKOPF-PLZ               PIC X(6).
           05  VERSANDKOPF-ORT               PIC X(30).
           05  VERSANDKOPF-LAND              PIC X(4).
           05  FILLER                        PIC X(10) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-5.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Versandmodus:     '.
           05  VERSANDKOPF-VERSANDMODUS      PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDPOSTENTITEL.
           05  FILLER                        PIC X    VALUE '|'.
           05  FILLER                        PIC X(9) VALUE 'Bestellnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(9) VALUE 'Artikelnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(30) VALUE
              ' Artikelbezeichnung '.
           05  FILLER                        PIC X(6)  VALUE SPACES.
           05  FILLER                        PIC X(6)  VALUE 'Menge'.
           05  FILLER                        PIC X(08) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDPOSTENZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  VERSANDZEILE-BESTELLNR        PIC X(6).
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  VERSANDZEILE-ARTIKELNR        PIC X(6).
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  VERSANDZEILE-ARTIKELNAME      PIC X(30).
           05  FILLER                        PIC X(6)  VALUE SPACES.
           05  VERSANDZEILE-BESTELLMENGE     PIC ZZZZZ9.
           05  FILLER                        PIC X(10) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDFUSS-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(52) VALUE
               'Summe der zu lieferenden Artikel:         '.
           05  VERSANDFUSS-MENGE             PIC ZZZ999.
           05  FILLER                        PIC X(10) VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FEHLERMELDUNG                 PIC X(70).
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERMELDUNGEN.
           05  FM-1                          PIC X(50) VALUE
              '   Lieferungsdaten sind fehlerhaft              '.
           05  FM-2                          PIC X(50) VALUE
              '   Anzahl Lieferposten stimmt nicht ueberein    '.
           05  FM-3                          PIC X(50) VALUE
              '   Lieferung darf nicht erfolgen !!!            '.
      ****************************************************************
      *  Parameters from calling interface
      *
       01  CMD-LINE                          PIC X(80).
       01  RESULT                            PIC X  COMP-X.
       01  FUNCT                             PIC X  COMP-X VALUE 35.
       01  CMD-LINED.
           05  CMD-LINE-LNG                  PIC X  COMP-X VALUE ZERO.
      *
      ************************************************************
WRAP       COPY DISPATC.cpy.
WRAP  *************** COBWRAP parameters ******************************
WRAP  *  Parameters for COBOL Programs
WRAP   01 X-COBOL-PARAMS.
WRAP      05  X-REC-LNG                PIC 9(8) USAGE BINARY.
WRAP      05  X-MAP-LNG                PIC 9(8) USAGE BINARY.
WRAP      05  X-ACCEPT-LNG             PIC 9999.
WRAP      05  X-DISPLAY-LNG            PIC 9999.
WRAP      05  X-ACCEPT-TEXT            PIC X(80).
WRAP      05  X-DISPLAY-TEXT           PIC X(80).
WRAP  *****************************************************************
WRAP  *  Parameters for data exchange between Program & Wrapper
WRAP  *
WRAP   01 X-PARAMS.
WRAP      05  X-FUNCODE                PIC XX.
WRAP      05  X-RETCODE                PIC 99.
new       05  X-FILNAME                PIC X(80).
WRAP      05  X-METHOD                 PIC X(30).
********************  End COBWRAP Parameters *************************
       PROCEDURE DIVISION.
      *****************************************************
       VERSANDSTEUERUNG SECTION.
      *****************************************************
       INIT-VERSAND.
           ACCEPT CMD-LINE FROM COMMAND-LINE
           MOVE CMD-LINE TO INPUT-FILE
TEST***    DISPLAY 'start Versand Process'
TEST***    DISPLAY 'Input File = ' INPUT-FILE
TEST***    ACCEPT CONTINUE-KEY
           MOVE 'Versandauftrag   ' TO KOPFZEILE-TITEL.
           MOVE 'Auftragsbearbeitung ' TO KOPFZEILE-PROGRAM.
           MOVE VERSANDTITEL TO TITELZEILE-7.
           PERFORM OPEN-LISTE.
           EXIT.
      *****************************************************
       OPEN-VERSANDPOSTEN.
           MOVE ZEROES TO DISPATCH-STATUS.
WRAP  *    OPEN INPUT DISPATCH-FILE
           IF DISPATCH-STATUS NOT = ZEROES
              DISPLAY 'DISPATCH File not found'
              DISPLAY 'DISPATCH File Name = ' INPUT-FILE
              DISPLAY 'Press Enter to terminate !'
              ACCEPT  CONTINUE-KEY
              GOBACK
           END-IF.
      *****************************************************
       READ-VERSANDPOSTEN.
           MOVE ZEROES TO DISPATCH-STATUS.
           PERFORM UNTIL EOF-DISPATCH
WRAP  *       READ DISPATCH-FILE
WRAP  *       AT END MOVE '09' TO DISPATCH-STATUS
WRAP       MOVE 'RD' TO X-FUNCODE
WRAP       MOVE ZEROES TO X-RETCODE
WRAP       MOVE INPUT-FILE TO X-FILNAME
WRAP       MOVE 'DISPATCH-FILE' TO X-METHOD
WRAP       MOVE 152 TO X-REC-LNG
WRAP       CALL 'DISPATCH' USING X-FUNCODE, X-RETCODE,
WRAP                             X-FILNAME, X-METHOD,
WRAP                             X-REC-LNG, DISPATCH-ORDER
TEST       DISPLAY 'DISPATCH-ORDER = ' DISPATCH-ORDER (1:40)
TEST       DISPLAY 'Press Enter to process '
TEST       ACCEPT CONTINUE-KEY
WRAP       IF X-RETCODE NOT = ZEROES
                     MOVE '09' TO DISPATCH-STATUS
              ELSE
                  IF DISP-REC-TYPE = 'DI'
                     IF DISP-CUST-NO NOT = LAST-CUST-NO
                        IF LAST-CUST-NO NOT = ZEROES
                           PERFORM DRUCKE-VERSANDFUSS
                        END-IF
                        PERFORM DRUCKE-VERSANDKOPF
                     END-IF
                     PERFORM DRUCKE-VERSANDPOSTEN
                  ELSE
                     DISPLAY 'Ungltige Versandsatzart=' DISP-REC-TYPE
TEST***              DISPLAY 'Press Enter to acknowledge!'
TEST***              ACCEPT  CONTINUE-KEY
                  END-IF
WRAP       END-IF
              MOVE DISP-ORDER-NO TO LAST-ORDER-NO
              MOVE DISP-CUST-NO  TO LAST-CUST-NO
           END-PERFORM.
           EXIT.
      *****************************************************
       CLOSE-VERSANDPOSTEN.
NEW        PERFORM DRUCKE-VERSANDFUSS
WRAP  *    CLOSE DISPATCH-FILE.
           GOBACK.
      *****************************************************************
      *****************************************************************
       VERSANDAUSGABE   SECTION.
      *****************************************************
       DRUCKE-VERSANDKOPF.
           ADD  1 TO VERSAND-NR
           MOVE VERSAND-NR TO VERSANDKOPF-RECHNR
           MOVE DISP-ORDER-NO TO VERSANDKOPF-AUFTRAGNR
           MOVE DISP-CUST-NO TO VERSANDKOPF-KUNDENKZ
           MOVE DISP-CUST-NAME TO  VERSANDKOPF-KUNDENNAME
           MOVE DISP-CUST-ZIP TO  VERSANDKOPF-PLZ
           MOVE DISP-CUST-CITY TO  VERSANDKOPF-ORT
           MOVE DISP-CUST-STREET TO  VERSANDKOPF-STRASSE
           MOVE DISP-CUST-STATE TO  VERSANDKOPF-LAND
           EVALUATE DISP-DELIVERY-MODE
               WHEN 'POST'
                   MOVE VERSANDMODUS-1 TO VERSANDKOPF-VERSANDMODUS
               WHEN 'LUFT'
                   MOVE VERSANDMODUS-2 TO VERSANDKOPF-VERSANDMODUS
               WHEN 'SPEC'
                   MOVE VERSANDMODUS-3 TO VERSANDKOPF-VERSANDMODUS
               WHEN OTHER
                   MOVE VERSANDMODUS-4 TO VERSANDKOPF-VERSANDMODUS
           END-EVALUATE
           PERFORM PRINT-HEADER
           MOVE ZERO TO GESAMTMENGE
           MOVE ZERO TO VERSAND-POSTEN-NR.
      *****************************************************
       DRUCKE-VERSANDPOSTEN.
NEW********IF  DISP-ORDER-NO = LAST-ORDER-NO
NEW********AND DISP-CUST-NO  = LAST-CUST-NO
              ADD 1 TO VERSAND-POSTEN-NR
              ADD DISP-ART-AMOUNT TO GESAMTMENGE
              MOVE DISP-ITEM-NO TO VERSANDZEILE-BESTELLNR
              MOVE DISP-ART-NO TO VERSANDZEILE-ARTIKELNR
              MOVE DISP-ART-NAME TO VERSANDZEILE-ARTIKELNAME
              MOVE DISP-ART-AMOUNT TO VERSANDZEILE-BESTELLMENGE
              MOVE VERSANDPOSTENZEILE TO VERSANDZEILE
              PERFORM PRINT-LINE.
NEW********END-IF.
      *****************************************************
       DRUCKE-VERSANDFUSS.
           MOVE GESAMTMENGE TO VERSANDFUSS-MENGE
           MOVE VERSANDFUSS-1 TO FUSSZEILE-2
           PERFORM PRINT-FOOTING
           PERFORM PAGE-CHANGE.
           EXIT.
      *****************************************************************
      *****************************************************************
       SUBROUTINES SECTION.
      *****************************************************
       OPEN-LISTE.
           OPEN OUTPUT VERSANDDATEI.
           ACCEPT TAGESDATUM FROM DATE.
           MOVE TAG TO LISTENTAG.
           MOVE MONAT TO LISTENMONAT.
           MOVE JAHR TO LISTENJAHR.
           MOVE LISTENDATUM TO KOPFZEILE-DATUM.
           MOVE SEITENNR TO KOPFZEILE-SEITE.
           MOVE VERSANDPROGRAM TO KOPFZEILE-PROGRAM
           MOVE VERSANDTITEL TO TITELZEILE-7
           EXIT.
      *****************************************************
       PRINT-HEADER.
           MOVE SEITENNR TO KOPFZEILE-SEITE
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           WRITE VERSANDSATZ FROM KOPFZEILE-2
           WRITE VERSANDSATZ FROM KOPFZEILE-3
           WRITE VERSANDSATZ FROM KOPFZEILE-4
           WRITE VERSANDSATZ FROM KOPFZEILE-2
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           WRITE VERSANDSATZ FROM TITELZEILE-7
           WRITE VERSANDSATZ FROM TITELZEILE-8
           WRITE VERSANDSATZ FROM VERSANDKOPF-1
           WRITE VERSANDSATZ FROM VERSANDKOPF-2
           WRITE VERSANDSATZ FROM VERSANDKOPF-3
           WRITE VERSANDSATZ FROM VERSANDKOPF-4
           WRITE VERSANDSATZ FROM VERSANDKOPF-5
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           WRITE VERSANDSATZ FROM VERSANDPOSTENTITEL
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           MOVE 16 TO ZEILENANZAHL
           ADD 1 TO SEITENNR.
           EXIT.
      *****************************************************
       PRINT-LINE.
           MOVE VERSANDPOSTENZEILE TO VERSANDZEILE.
           WRITE VERSANDSATZ.
           ADD 1 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PRINT-FOOTING.
           WRITE VERSANDSATZ FROM FUSSZEILE-1
           WRITE VERSANDSATZ FROM FUSSZEILE-2
           WRITE VERSANDSATZ FROM FUSSZEILE-1
           ADD 3 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PAGE-CHANGE.
           MOVE SPACES TO VERSANDSATZ
           MOVE  '/' TO VERSANDSATZ
           WRITE VERSANDSATZ AFTER PAGE.
           EXIT.
      * end of source
      ******************************************************************
