// Bugs list (and to do):
// 1. Stall things before restart() does its thing
// 2. Import only needed stuff
// 3. Fix dollar amount display to always show two decimals
// 4. Sounds cannot overlap (device busy).  Synchronize.
// 5. Display useraccount.getName() during PIN prompt
// 6. Trouble when initially hiding the numpanel and actpanel due to FlowLayout

// Too many things are imported now, but I am too lazy to prune the list.
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.util.Vector;
import java.net.*;
import java.lang.*;

public class ATMApp extends Applet {
    Button b1, b2, b3, b4, b5, b6, b7, b8, b9, b0,
           checking, savings, withdraw, deposit, balance, transfer,
           cancel, enter, insert;
    Panel numpanel = new Panel();
    Panel actpanel = new Panel();
    Panel cardpanel = new Panel();
    TextArea outarea;
    TextField card;
    Integer cardnumber;
    Account useraccount; // see class defined below (datastructure)
    // flags for tracking the state of the ATM (see the event handler)
    boolean card_flag, pin_flag, numbers_on, account_on, action_on, continue_on;
    String filename;
    Vector bankvec =  new Vector();  // bankvec is a vector of Accounts
    // parameters for holding information Input by the user
    int digit_in, userpin, useramt, pintry;
    float user_amount;
    int action_account; // 1 = checking, 2 = savings
    int user_action;    // 1 = withdraw, 2 = deposit, 3 = transfer, 4 = balance
    int pinmask = 142;  // position for drawing the PIN x's

    public void init() {
        setBackground(Color.lightGray);
        setLayout(new FlowLayout());
        setFont(new Font("TimesRoman",Font.BOLD,18));
        pintry = 0;
        userpin = 0;
        useramt = 0;
        user_action = 0;
        action_account = 0;
        card_flag = false;
        numbers_on = false;
        account_on = false;
        continue_on = false;
        pin_flag = false;
        filename = "rstaccts.dat";
        readFile();
        card.requestFocus();
   }

    private void restart() {
        // System.out.println("RESTART");
        pintry = 0;
        userpin = 0;
        useramt = 0;
        user_action = 0;
        action_account = 0;
        card_flag = false;
        numbers_on = false;
        account_on = false;
        continue_on = false;
        pin_flag = false;
        showString("     Welcome to RSB's Internet Teller\n\n                                 Insert your card \n      (type in an account number and press the button).");
        card.setEditable(true);
        card.setText("");
        actpanel.hide();
        numpanel.hide();
        cardpanel.show();
        card.requestFocus();
    }

    private void readFile() {
        // read in the datafile from RST server and load the bank
        // use the URL class so that it works over the 'net
        Account curr_account;
        StreamTokenizer st;
        InputStream fis;

        try {
                Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
                fis = new URL(getDocumentBase(), filename).openStream();
                st = new StreamTokenizer(fis);
                st.eolIsSignificant(true);
                st.parseNumbers();
        // read in the file, line by line (file has a particular format)
scan:
        while (true) {
            switch (st.nextToken()) {
              default:
                break scan;
              case StreamTokenizer.TT_EOL:
                break;
              case StreamTokenizer.TT_WORD:
                curr_account = new Account();
                if ("a".equals(st.sval)) {
                   if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                      curr_account.Cardnumber = (int) st.nval;
                      if (st.nextToken() == StreamTokenizer.TT_WORD) {
                        curr_account.Firstname = st.sval;
                        if (st.nextToken() == StreamTokenizer.TT_WORD) {
                            curr_account.Middlename = st.sval;
                            if (st.nextToken() == StreamTokenizer.TT_WORD) {
                                curr_account.Lastname = st.sval;
                                if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                    curr_account.Pin = (int) st.nval;
                                    if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                        curr_account.Checking_account = (int) st.nval;
                                        if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                            curr_account.Checking_balance = (float) st.nval;
                                            if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
                                                curr_account.Savings_account = (int) st.nval;
                                                if (st.nextToken() == StreamTokenizer.TT_NUMBER)
                                                   curr_account.Savings_balance = (float) st.nval;
                }}}}}}}} // close nested if's (what is this, scheme?!)
                bankvec.addElement(curr_account);
                while (st.ttype != StreamTokenizer.TT_EOL && st.ttype != StreamTokenizer.TT_EOF)
                      st.nextToken();
                break;
                 } else {
                   while (st.nextToken() != StreamTokenizer.TT_EOL && st.ttype != StreamTokenizer.TT_EOF);
                }
            }
        }
        try {
                fis.close(); }
        catch(Exception e) {
                System.out.println("Error closing URL"); }
        } //end upper try
        catch(Exception e) {
                System.out.println("Error opening URL");
        }
        // System.out.println(bankvec.toString());
    }

    public ATMApp() {
        // start things rolling
        outarea = new TextArea("\n\n Welcome to RSB's Internet Teller\n\n  Insert your card\n (type in an account number and press the button).",8,50);
        outarea.setEditable(false);
        add(outarea);
        add(CardPanel(cardpanel));
        add(NumPanel(numpanel));
        add(ActPanel(actpanel));
        card.requestFocus();
     }

    private Account checkCard(Integer cardno) {
        // check a card to see if it is valid
        // also (re)set card_flag
        Account record;

        for (int i = 0; i < bankvec.size(); i++) {
             record = (Account) bankvec.elementAt(i);
             if (record.getCardnumber() == cardno.intValue()) {
                return record; }
        }
        showString("Invalid card.");
        play(getCodeBase(), "sounds/that.hurts.au");
        card_flag = false;
        restart();
        return null;
    }

    private boolean checkPin() {
        // check the PIN number, 3 tries are allowed

        pintry += 1;
        if (userpin == useraccount.getPin()) {
           numbers_on = false;  // switch states to get action_account
           account_on = true;
           showString("Please choose an account.\n\n           Use the buttons below.");
           play(getCodeBase(), "sounds/choose.au");
           return true;
        }
        else {
             if (pintry >= 3) {
                showString("Invalid PIN.\n\n           Sorry, your card has been retained.");
                play(getCodeBase(), "sounds/sorry.au");
                restart();
                return false;
             }
             else {
                  showString("Invalid PIN.\n\n           Please enter PIN again now: ");
                  play(getCodeBase(), "sounds/pin.au");
                  userpin = 0;
                  return false;
                  }
             }
    }

    private int addDigit(int digit_in, int acc) {
        // add a digit to the accumulator (for PIN and amount grabbing)
        return ((10 * acc) + digit_in);
    }

    private void showBalance(int act) {
        // display balance of either account
        if (act == 1) {  // checking
           showString("Your Checking balance is $" + useraccount.getChecking());
        }
        else if (act == 2) {  // savings
                showString("Your Savings balance is $" + useraccount.getSavings());
        }
    }

    private void showAmount(int action) {
        // display an amount.  This is still buggy. ****
        // should force two decimal places but doesn't.  how?
        Float famt;

        switch(action) {
        case 1:
                showString("Please enter a dollar amount to withdraw.\n\n           $ ");
                break;
        case 2:
                showString("Please enter a dollar amount to deposit.\n\n           $ ");
                break;
        case 3:
                showString("Please enter a dollar amount to transfer.\n\n           $ ");
                break;
        default:
        }
        user_amount = (float) useramt / 100;
        famt = new Float(user_amount);
        outarea.insertText(famt.toString(famt.floatValue()),pinmask);
    }

    private void doAction(int act, float amt) {
        // perform an action on an account
        // act specifies the account to use
        // amt specifies the amount involved
        // this function uses a mathematical checker to make sure only valid
        // account manipulation is happening
        Float amount;
        float checksum1, checksum2; // validate transactions

        amount = new Float(amt);
        checksum1 = useraccount.getChecking() + useraccount.getSavings();
        checksum2 = -1;
        switch(act) {
        case 1: // withdraw
                switch(action_account) {
                case 1: //checking
                        if (useraccount.getChecking() >= amt) {
                            showString("Withdrawing $"+amount.toString(amount.floatValue())+ 
                            " from checking.\n\n           New Checking balance is $"+ (useraccount.getChecking() - amt));
                            useraccount.Checking_balance = useraccount.getChecking() - amt;
                            checksum2 = useraccount.getChecking() + useraccount.getSavings() + amt;

                        }
                        else {
                             showString("Sorry, you may not withdraw $"+amount.toString(amount.floatValue())+ 
                             "\n          since your balance is $"+ useraccount.getChecking());
                             checksum2 = useraccount.getChecking() + useraccount.getSavings();

                        }
                        break;
                case 2: //savings
                        if (useraccount.getSavings() >= amt) {
                            showString("Withdrawing $"+amount.toString(amount.floatValue())+ 
                            "from savings.\n\new Savings balance is $"+ (useraccount.getSavings() - amt));
                            useraccount.Savings_balance = useraccount.getSavings() - amt;
                            checksum2 = useraccount.getChecking() + useraccount.getSavings() + amt;

                        }
                        else {
                             showString("Sorry, you may not withdraw $"+amount.toString(amount.floatValue())+ 
                            "\n          since your balance is $"+ useraccount.getSavings());
                            checksum2 = useraccount.getChecking() + useraccount.getSavings();
                        }
                        break;
                default:
                }
                break;
        case 2: // deposit
                checksum1 += amt;
                switch(action_account) {
                case 1: // checking
                        showString("Deposited $"+amount.toString(amount.floatValue())+ 
                        " to checking.\n\n           New Checking balance is $"+ (useraccount.getChecking() + amt));
                        useraccount.Checking_balance = useraccount.getChecking() + amt;
                        break;
                case 2: // savings
                        showString("Deposited $"+amount.toString(amount.floatValue())+ 
                        " to savings.\n\n           New Savings balance is $"+ (useraccount.getSavings() + amt));
                        useraccount.Savings_balance = useraccount.getSavings() + amt;
                break;
                default:
                }
                checksum2 = useraccount.getChecking() + useraccount.getSavings() + amt;
                break;
        case 3: // transfer
                switch(action_account) {
                case 1: //checking
                        if (useraccount.getChecking() >= amt) {
                            showString("Transferring $"+amount.toString(amount.floatValue())+ 
                            " from checking to savings.\n New Checking balance is $"+ (useraccount.getChecking() - amt)+
                            "\n           New Savings balance is $"+ (useraccount.getSavings() + amt));
                            useraccount.Checking_balance = useraccount.getChecking() - amt;
                            useraccount.Savings_balance = useraccount.getSavings() + amt;
                        }
                        else {
                             showString("Sorry, you may not transfer $"+amount.toString(amount.floatValue())+ 
                             "\n since your balance is $"+ useraccount.getChecking());
                        }
                        break;
                case 2: //savings
                        if (useraccount.getSavings() >= amt) {
                            showString("Transferring $"+amount.toString(amount.floatValue())+ 
                            " from savings to checking.\n New Savings balance is $"+ (useraccount.getSavings() - amt)+
                            "\n           New Checking balance is $"+ (useraccount.getChecking() + amt));
                            useraccount.Savings_balance = useraccount.getSavings() - amt;
                            useraccount.Checking_balance = useraccount.getChecking() + amt;
                        }
                        else {
                             showString("Sorry, you may not transfer $"+amount.toString(amount.floatValue())+ 
                             "\n          since your balance is $"+ useraccount.getChecking());
                        }
                        break;
                default:
                }
                checksum2 = useraccount.getChecking() + useraccount.getSavings();
                break;
        default:
        }
        // this should really throw an exception...oh well
        if (! (checksum1 == checksum2) ) {
           System.out.println("TRANSACTION ERROR"); }
        user_amount = (float) 0;
        useramt = 0;
    }

//  Display and control stuff from here down

    private void showString(String s) {
        // draw something in the TextArea
        outarea.replaceText("\n\n           "+s,0,400);
    }

    private void appendString(String s) {
        // add some text to the TextArea
        outarea.replaceText("\n\n           "+s,350,400);
    }

    private Panel CardPanel(Panel p) {
        // Card insertion panel...simulates putting in a physical card
        insert = new Button("          Accept ATM card number         --> ");
        card = new TextField(12);
        p.add(insert);
        p.add(card);
        return(p);
    }

    private Panel ActPanel(Panel p) {
        // Draw an activity panel with buttons for each possible action
        p.setLayout(new GridLayout(4,2,2,2));
        checking = new Button("Checking");
        savings = new Button("Savings");
        withdraw = new Button("Withdraw");
        deposit = new Button("Deposit");
        balance = new Button("Balance");
        transfer = new Button("Transfer");
        cancel = new Button("CANCEL");
        enter = new Button("ENTER");
        p.add(checking);
        p.add(savings);
        p.add(withdraw);
        p.add(deposit);
        p.add(balance);
        p.add(transfer);
        p.add(cancel);
        p.add(enter);
        return(p);
    }

    private Panel NumPanel(Panel p) {
        // Draw a number panel with 10 buttons
        p.setLayout(new GridLayout(4,3,2,2));
        b1 = new Button("1");
        b2 = new Button("2");
        b3 = new Button("3");
        b4 = new Button("4");
        b5 = new Button("5");
        b6 = new Button("6");
        b7 = new Button("7");
        b8 = new Button("8");
        b9 = new Button("9");
        b0 = new Button("0");
        p.add(b1);
        p.add(b2);
        p.add(b3);
        p.add(b4);
        p.add(b5);
        p.add(b6);
        p.add(b7);
        p.add(b8);
        p.add(b9);
        p.add(b0);
        return(p);
    }

    public boolean handleEvent(Event evt) {
        // here is where the control loop is actualized
        // there are several flags for the operating modes
        // the flags are: card_flag << valid card entered?
        //                pin_flag  << valid PIN number entered
        //                numbers_on << enter PIN or amount
        //                accounts_on << choose base account to use
        //                action_on << choose an action to perform
        //                continue_on << ENTER to go on
        switch(evt.id) {
            case Event.ACTION_EVENT: {
              if (card_flag == true) {
                if (numbers_on == true) {
                // each numeric button can be used to enter a PIN or an amount
                // digit.  Thus two parts.
                if ("1".equals(evt.arg))
                {
                        showStatus("1 pressed");
                        play(getCodeBase(), "sounds/touchtone.1.au");
                        digit_in = 1;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if ("2".equals(evt.arg))
                {
                        showStatus("2 pressed");
                        play(getCodeBase(), "sounds/touchtone.2.au");
                        digit_in = 2;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("3".equals(evt.arg))
                {
                        showStatus("3 pressed");
                        play(getCodeBase(), "sounds/touchtone.3.au");
                        digit_in = 3;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("4".equals(evt.arg))
                {
                        showStatus("4 pressed");
                        play(getCodeBase(), "sounds/touchtone.4.au");
                        digit_in = 4;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("5".equals(evt.arg))
                {
                        showStatus("5 pressed");
                        play(getCodeBase(), "sounds/touchtone.5.au");
                        digit_in = 5;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("6".equals(evt.arg))
                {
                        showStatus("6 pressed");
                        play(getCodeBase(), "sounds/touchtone.6.au");
                        digit_in = 6;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("7".equals(evt.arg))
                {
                        showStatus("7 pressed");
                        play(getCodeBase(), "sounds/touchtone.7.au");
                        digit_in = 7;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("8".equals(evt.arg))
                {
                        showStatus("8 pressed");
                        play(getCodeBase(), "sounds/touchtone.8.au");
                        digit_in = 8;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("9".equals(evt.arg))
                {
                        showStatus("9 pressed");
                        play(getCodeBase(), "sounds/touchtone.9.au");
                        digit_in = 9;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                else  if("0".equals(evt.arg))
                {
                        showStatus("0 pressed");
                        play(getCodeBase(), "sounds/touchtone.0.au");
                        digit_in = 0;
                        if (! pin_flag) {
                                userpin = addDigit(digit_in, userpin);
                                outarea.insertText("X",pinmask);
                                pinmask++;
                        }
                        else { // get numerical input for amount
                                useramt = addDigit(digit_in, useramt);
                                showAmount(user_action);
                        }
                        return true;
                }
                // accept the accumulator as PIN or amount
                else  if("ENTER".equals(evt.arg))
                {
                        showStatus("ENTER pressed");
                        // play(getCodeBase(), "sounds/thin.bell.au");
                        if (! pin_flag) {
                           pin_flag = checkPin();
                           pinmask = 142; //reset pinmask
                        }
                        else { // amount entered...floatify it
                                doAction(user_action, user_amount);
                                appendString("Press ENTER for another transcation.");
                                numbers_on = false;
                                continue_on = true;
                        }
                        return true;
                }
                // a special CANCEL for numbers clears the accumulator
                else  if("CANCEL".equals(evt.arg))
                {
                        showStatus("CANCEL pressed");
                        if (! pin_flag) {
                           userpin = 0;
                           pinmask = 142;
                           showString("Please enter your PIN number: ");
                           play(getCodeBase(), "sounds/pin.au");
                        }
                        else {
                           useramt = 0;
                           showAmount(user_action);
                        }
                        return true;
                }
                } // numbers_on section END
                else  if (account_on == true) {
                // section for choosing an account
                if("Checking".equals(evt.arg))
                {
                        showStatus("Checking pressed");
                        action_account = 1;
                        //play(getCodeBase(), "sounds/thin.bell.au");
                        if (useraccount.checkChecking() == true) {
                           account_on = false;
                           action_on = true;
                           showString("Please choose a Checking transaction type.\n\n           Use the buttons below.");
                           play(getCodeBase(), "sounds/action.au");
                        }
                        else {
                                showString("You have no checking account.\n\n           Please choose a valid account now.");
                        }
                        return true;
                }
                else  if("Savings".equals(evt.arg))
                {
                        showStatus("Savings pressed");
                        action_account = 2;
                        //play(getCodeBase(), "sounds/thin.bell.au");
                        if (useraccount.checkSavings() == true) {
                           account_on = false;
                           action_on = true;
                           showString("Please choose a Savings transaction type.\n\n           Use the buttons below.");
                           play(getCodeBase(), "sounds/action.au");
                        }
                        else {
                                showString("You have no savings account.\n           Please choose a valid account.");
                        }
                        return true;
                }
                else  if("CANCEL".equals(evt.arg))
                {
                        showString("Thank you for banking with RST.");
                        showStatus("CANCEL pressed");
                        play(getCodeBase(), "sounds/thanks.au");
                        restart();
                        return true;
                }
                } // account_on section END
                else if (action_on == true) {
                // section for choosing an action
                if("Withdraw".equals(evt.arg))
                {
                        showStatus("Withdraw pressed");
                        //play(getCodeBase(), "sounds/thin.bell.au");
                        action_on = false;
                        numbers_on = true;
                        showString("Please enter a dollar amount to withdraw.\n\n           $ ");
                        user_action = 1;
                        play(getCodeBase(), "sounds/amount.au");
                        return true;
                }
                else  if("Deposit".equals(evt.arg))
                {
                        showStatus("Deposit pressed");
                        //play(getCodeBase(), "sounds/thin.bell.au");
                        action_on = false;
                        numbers_on = true;
                        showString("Please enter a dollar amount to deposit.\n\n           $ ");
                        play(getCodeBase(), "sounds/amount.au");
                        user_action = 2;
                        return true;
                }
                else  if("Transfer".equals(evt.arg))
                {
                        //play(getCodeBase(), "sounds/thin.bell.au");
                        showStatus("Transfer pressed");
                        if ((useraccount.checkChecking() == true) &&
                            (useraccount.checkSavings() == true)) {
                            action_on = false;
                            numbers_on = true;
                            showString("Please enter a dollar amount to transfer.\n\n           $ ");
                            play(getCodeBase(), "sounds/amount.au");
                            user_action = 3;
                        }
                        else {
                            showString("You do not have another account with RSTbank.");
                            appendString("Press ENTER for another transcation.");
                            continue_on = true;
                            action_on = false;
                        }
                        return true;
                }
                else  if("Balance".equals(evt.arg))
                {
                        showStatus("Balance pressed");
                        //play(getCodeBase(), "sounds/thin.bell.au");
                        showBalance(action_account);
                        appendString("Press ENTER for another transcation.");
                        action_on = false;
                        continue_on = true;
                        return true;
                }
                else  if("CANCEL".equals(evt.arg))
                {
                        showString("Thank you for banking with RST.");
                        showStatus("CANCEL pressed");
                        play(getCodeBase(), "sounds/thanks.au");                                       restart();
                        return true;
                }
                } //action_on section END
                else if (continue_on == true) {
                // section for doing it all again (continue)
                if("ENTER".equals(evt.arg))
                {
                        showString("Please choose an account.\n\n           Use the buttons below.");
                        play(getCodeBase(), "sounds/choose.au");
                        numbers_on = false;
                        account_on = true;
                        action_on = false;
                        showStatus("ENTER pressed");
                        //play(getCodeBase(), "sounds/thin.bell.au");
                        if (! pin_flag) {
                           pin_flag = checkPin(); }
                        return true;
                }
                else  if("CANCEL".equals(evt.arg))
                {
                        showString("Thank you for banking with RST.");
                        showStatus("CANCEL pressed");
                        play(getCodeBase(), "sounds/thanks.au");                                       restart();
                        return true;
                }
                } //continue_on section END
                // default CANCEL event
                else  if("CANCEL".equals(evt.arg))
                {
                        showString("Thank you for banking with RST.");
                        showStatus("CANCEL pressed");
                        play(getCodeBase(), "sounds/thanks.au");                                       restart();
                        return true;
                }
                else {
                        play(getCodeBase(), "sounds/ding.au");
                }
              } // card_flag is false card not yet in machine
                // this is where the event loop really begins
                // get a card from the user and vallidate it
              else if("          Accept ATM card number         --> ".equals(evt.arg))
                        {
                        showStatus("INSERT CARD");
                        card_flag = true;
                        card.setEditable(false);
                        try {
                                cardnumber = new Integer(card.getText().toString());
                        }
                        catch(Exception e) { // handle illegal card entry
                                card_flag = false;
                                card.setEditable(true);
                                card.setText("");
                                play(getCodeBase(), "sounds/that.hurts.au");
                                return false;
                        }
                        useraccount = checkCard(cardnumber);
                        if (card_flag == true) {
                                //remove(cardpanel);
                                cardpanel.hide();
                                actpanel.show();
                                numpanel.show();
                                showString("Please enter your PIN number: ");
                                play(getCodeBase(), "sounds/pin.au");
                                numbers_on = true;
                                return true; }
                        else {
                                return false;
                             }
                        }
                     else {
                        play(getCodeBase(), "sounds/ding.au");
                        return false;
                     }
            }
        }
        return false;
    }
}

// This class is a very simple datastructure for account records
class Account {
        int Cardnumber;
        String Firstname;
        String Middlename;
        String Lastname;
        int Pin;
        int Checking_account;
        float Checking_balance;
        int Savings_account;
        float Savings_balance;

        int getCardnumber() {
                return Cardnumber;
        }
        int getPin() {
                return Pin;
        }
        boolean checkChecking() {
                if (Checking_account == -1) {
                   return false; }
                else {
                   return true; }
        }
        boolean checkSavings() {
                if (Savings_account == -1) {
                   return false; }
                else {
                   return true; }
        }
        float getChecking() {
                return Checking_balance;
        }
        float getSavings() {
                return Savings_balance;
        }
        String getName() {
        String catname = "";

                catname.concat(Firstname);
                catname.concat(" ");
                catname.concat(Lastname);
                return catname;
        }

}
//------------------------------------------------------------------
//X-Sun-Data-Type: default
//X-Sun-Data-Name: MailMerge.java
//X-Sun-Charset: us-ascii
//X-Sun-Content-Lines: 1079

/**
 *  This code is from the book:
 *
 *    Winder, R and Roberts, G (1998) <em>Developing Java
 *    Software</em>, John Wiley & Sons.
 *
 *  It is copyright (c) 1997 Russel Winder and Graham Roberts.
 */

import java.io.* ;
import java.awt.* ;
import java.awt.event.* ;
//
//  A program to do a mail merge of a LaTeX2e letter class template
//  with an address file.  The address file contains records which
//  contain fields for name, telephone, fax, email and address.  For
//  each record, the LaTeX2e letter file is copied and edited and this
//  edited letter file "compiled" to DVI, processed to produce
//  PostScript and then the PostScript file spooled for printing.
//  Changing one of the constants would enable production of other
//  formats from DVI.  This program was developed on a UNIX
//  environment but should also be usable, possible perhaps with
//  amendments to the initial constants, on a Windows platform.
//
//  The LaTeX2e template is a standard LaTeX2e letter class file but
//  with the markers <NAME>, <TELEPHONE>, <FAX>, <EMAIL>, <ADDRESS>
//  replacing actual data.  The address file contains entries using
//  these markers as introducers, for example:
//
//      <NAME> A Person
//      <TELEPHONE> 0999 1234 1234
//      <FAX> 0999 4321 4321
//      <EMAIL> A.Person@somhost.or.other
//      <ADDRESS> 1 Some Street
//      A City
//      CountryX
//
//  Each record in the address file is terminated by a blank line.
//  The address must be the last field of the record but the other can
//  appear in any order.  Indeed they can appear many times but the
//  last entry for each field is the one used.
//
//  Make the application a subclass of Frame so that there is a parent
//  Window for all the other Windows.  The others will be made
//  visible, this one will remain hidden at all times.
//
//  Version 1.0 25.5.97
//  Author Russel Winder
//
public class MailMerge extends Frame
{
    //
    //  The name of this command.  Used for the Window headers.
    //
    public final static String commandName = "Mail Merge" ;
    //
    //  The string constituting the summary of how to use the
    //  command if you want to use command line arguments.
    //
    private final static String usageString =
        "Usage: mmerge [[-P...] <letter file> <addresses file>]" ;
    //
    //  The strings for the various external commands that we are
    //  going to issue.  Also various strings to do with options and
    //  file names that are needed during command construction.
    //
    //  Serious issue regarding dvips and printing.  In my personal
    //  set up, dvips outputs to the standard output, it does not
    //  automatically send things to the printer.  Thus an explicit
    //  printing activity is required.  If this were C++, we would use
    //  the system(char*) function to handle the execution of the
    //  commands, which invokes the shell to interpret the command
    //  string -- this allows pipelining to be used, e.g. dvips
    //  file.dvi | lpr.  Runtime.exec(string) is the obvious analogue
    //  in Java but this does not use a shell to interpret commands.
    //  A design decision is required: Do we manage the files and
    //  manipulate things directly or do we spawn a shell to handle
    //  the pipelining.  Since spawning a shell leads to a shell that
    //  does not necessarily read the users path, do things
    //  explicitly.  This is almost certainly less UNIX specific as
    //  well.
    //
    //  NB.  The print command has to be constructed at run time since
    //  the user may want to specify a particualr printer.
    //
    //  defaultPrinter is the empty string so that the print command
    //  uses the users defaults.  Could have put something like
    //  "-PPostScript" but this would have made assumptions that are
    //  not really sensible.
    //
    private final static String defaultPrinter = "" ;
    private final static String printerParameterPrefix = "-P" ;
    private final static String tempFileRoot = "temp" ;
    private final static String latexExtender = ".ltx" ;
    private final static String dviExtender = ".dvi" ;
    private final static String psExtender = ".ps" ;
    //
    private final static String latexFileName =
        tempFileRoot + latexExtender ;
    private final static String dviFileName =
        tempFileRoot + dviExtender ;
    private final static String psFileName =
        tempFileRoot + psExtender ;
    //
    private final static String latexCommand =
        "latex " + latexFileName ;
    private final static String dvipsCommand =
        "dvips -o " + psFileName + " " + dviFileName ;
    private final static String printCommand = "lpr -h " ;
    //
    //  We need to remove all temporary files but we do not
    //  necessarily know all the file names that will be created; we
    //  know the root but not the extension.  Need to spawn a shell so
    //  that we can make use of wildcards in naming the files.  Need
    //  the quotes around the remove command to get the correct parse
    //  of the command.
    //
    //  Actually this does not seem to work, no files get removed.
    //  This is an, as yet, not understood problem.
    //
    private final static String deleteCommand =
        "sh -c \"rm -f " + tempFileRoot + ".*\"" ;
    //
    //  Strings to do with the markers that appear in the document
    //  template.
    //
    private final static char markerStartCharacter = '<' ;
    private final static char markerEndCharacter = '>' ;
    private final static String nameMarker =
        markerStartCharacter + "NAME" + markerEndCharacter ;
    private final static String telephoneMarker =
        markerStartCharacter + "TELEPHONE" + markerEndCharacter ;
    private final static String faxMarker =
        markerStartCharacter + "FAX" + markerEndCharacter ;
    private final static String emailMarker =
        markerStartCharacter + "EMAIL" + markerEndCharacter ;
    private final static String addressMarker =
        markerStartCharacter + "ADDRESS" + markerEndCharacter ;
    //
    //  There are some class scope data items.  This sort of data
    //  (accessible to all methods in the class) is usually considered
    //  a really bad idea but the justification here is as follows: To
    //  create an object (and hence class) to wrap these 4 data items
    //  seems like unecessary overkill but we cannot ask a method to
    //  return more than one item, thus the data items must be
    //  external to the method.
    //
    //  The data items are static since the methods are static and
    //  to do otherwise causes error messages from the compiler.
    //
    private static String name ;
    private static String telephone ;
    private static String fax ;
    private static String email ;
    private static String address ;
    //
    //  The locations for the file names that are extracted from the
    //  user.  These have package scope since there are various
    //  distinct objects (of differing classes), that need to access
    //  them.
    //
    static String letterFileName ;
    static String addressFileName ;
    static String printerName ;
    //
    //  The root frame of the applications needs to be accessible
    //  widely within the class so make it a class variable to save
    //  passing it as a parameter everywhere.
    //
    private final static MailMerge mm = new MailMerge() ;
    //
    //  Prepare the message list object.  Don't show it until it
    //  has some output.
    //
    private final static MessageBox mb =
        new MessageBox(commandName + " Messages") ;
    //
    //  The mail merge action consists of getting the relevant
    //  filename information from the user and then causing the
    //  actions to happen.  The information can be garnered in two
    //  ways from the command line or via a GUI if no command line
    //  arguments are given by the user.
    //
    public static void main(String[] args)
        throws IOException, InterruptedException
    {
        //
        //  As a safety measure (in case we have forgotten to close
        //  any open files in the code, or in case an exception
        //  actually happens) we force all finalizers to be executed
        //  at termination of the program.  This ensures all files
        //  will be properly closed.
        //
        System.runFinalizersOnExit(true) ;
        //
        //  Check for command line arguments.
        //
        if (args.length == 0)
        {
            //
            //  The user has given no command line parameters so go
            //  into GUI mode to get the filename and printer
            //  information from the user.
            //
            FilesSelector fs = new FilesSelector(mm) ;
        }
        else
        {
            //
            //  Process the parameters.  Need to keep track of which
            //  parameter is the letter file and which the address
            //  file since we may have a printer specification as one
            //  of the parameters.
            //
            //  NB.  Unlike C++, the parameter list does not include
            //  the name of the command, just the parameters to it so
            //  the first parameter is in position 0 of the array.
            //
            int letterFileIndex = 0 ;
            int addressFileIndex = 1 ;
            printerName = defaultPrinter ;
            //
            //  See if the first parameter starts with
            //  printerParameterPrefix.  If it does then the user has
            //  requested a specific printer so ensure we use it!
            //
            if (args[0].length() > 2)
            {
                if (args[0].substring(0, 2).
                    compareTo(printerParameterPrefix) == 0)
                {
                    printerName = printerParameterPrefix +
                                  args[0].substring(2) ;
                    letterFileIndex++ ;
                    addressFileIndex++ ;
                }
            }
            //
            //  Check to make sure we have a viable set of parameters.
            //
            if (addressFileIndex >= args.length)
            {
                terminate(1, "Too few parameters given.\n" +
                             usageString) ;
            }
            if (addressFileIndex < args.length - 1)
            {
                information("Excess parameter(s) ignored.") ;
            }
            //
            //  Set up the filenames and the file handles.
            //
            letterFileName = args[letterFileIndex] ;
            addressFileName = args[addressFileIndex] ;
        }
        //
        //  Report back to the user, via a pop-up window, the values
        //  of the parameters that are being used in this run.  This
        //  is a confirmation dialog, the program block until it
        //  returns.
        //
        Report r = new Report(mm) ;
        //
        //  Set up the file handles.
        //
        File letterFile = new File(letterFileName) ;
        File addressFile = new File(addressFileName) ;
        File latexFile = new File(latexFileName) ;
        File dviFile = new File(dviFileName) ;
        //
        //  Open the address file and process all the people that the
        //  address file contains details about.
        //
        //  NB.  Must declare the variable outside the try block to
        //  avoid having the wrong scope.  Explicitly initialize the
        //  variable since although we can deduce that an apprently
        //  uninitialized must be initialized if the program
        //  continues, the compiler cannot and fails to compile the
        //  program!
        //
        BufferedReader addressReader = null ;
        try
        {
            addressReader =
                new BufferedReader(new FileReader(addressFile)) ;
        }
        catch (FileNotFoundException e)
        {
            terminate(1, "Could not open address file " +
                         addressFileName + ".") ;
        }
        while (getPerson(addressReader))
        {
            //
            //  Read the letter file and write it out to the temporary
            //  LaTeX2e file ready for "compiling".  Ensure all the
            //  edit field markers are replaced with appropriate
            //  information.
            //
            //  NB.  The variables are declared outside the try blocks
            //  to avoid wrong scope.  Initialize them with somethng
            //  to keep the compiler happy.
            //
            BufferedReader letterReader = null ;
            try
            {
                letterReader =
                    new BufferedReader(new FileReader(letterFile)) ;
            }
            catch (FileNotFoundException e)
            {
                terminate(1, "Could not open letter file " +
                             letterFileName + ".") ;
            }
            BufferedWriter latexWriter = null ;
            try
            {
                latexWriter =
                    new BufferedWriter(new FileWriter(latexFile)) ;
            }
            catch (FileNotFoundException e)
            {
                terminate(1, "Could not open temporary file " +
                             latexFileName + ".") ;
            }
            //
            //  We must ensure that LaTeX2e works in batch mode so
            //  that if it comes across an error in the processing it
            //  does not enter interactive mode.
            //
            latexWriter.write("\\batchmode") ;
            latexWriter.newLine() ;
            while (true)
            {
                //
                //  Get a line from the letter file, check it for
                //  occurrences of the markers, edit out the markers
                //  for the real information and output the (possibly)
                //  modified line.
                //
                String currentLine = letterReader.readLine() ;
                if (currentLine == null)
                    break ;
                currentLine = editMarkers(currentLine) ;
                latexWriter.write(currentLine) ;
                latexWriter.newLine() ;
            }
            //
            //  Finished this merge so close things up.  Remember to
            //  reset the eof flag and rewind the letter file so it's
            //  ready for the next addressee.
            //
            latexWriter.close() ;
            letterReader.close() ;
            //
            //  Create and run the latex command, and the printing
            //  command then delete all the temporary files ready
            //  for the next letter.
            //
            //  NB.  MUST ensure that the commands terminate before
            //  the next begins.
            //
            executeCommand(latexCommand) ;
            executeCommand(dvipsCommand) ;
            executeCommand(printCommand + printerName +
                           ' ' + psFileName) ;
            executeCommand(deleteCommand) ;
        }
        addressReader.close() ;
    }
    //
    //  Output a message to the user.  Add this message to the
    //  messages list.
    //
    private static void information(final String s)
    {
        mb.append(s + '\n') ;
    }
    //
    //  A method interface to a run terminating dialog.  The dialog
    //  is a blocking dialog, i.e. modal, which exits the entire
    //  program as soon as the user acknowledges the dialog.  Remember
    //  we have to pass a reference to a Frame to act as the parent of
    //  the dialog.
    //
    private static void terminate(final int code, final String s)
    {
        TerminatingDialog td = new TerminatingDialog(mm, s, code) ;
    }
    //
    //  Get the details for the next person.  Can have any number of
    //  lines with any number of markers other than the address
    //  marker, followed by an address the end of which is the end of
    //  the record.  Obviously the last of any duplicates wins.
    //
    private static boolean
        getPerson(final BufferedReader addressReader)
        throws IOException
    {
        //
        //  Ensure that there is no carry over of information from one
        //  record to the next.
        //
        name = "" ;
        telephone = "" ;
        fax = "" ;
        address = "" ;
        //
        //  Do things until we get to the end of the record.
        //
        boolean completed = false ;
        while (! completed)
        {
            //
            //  Read a line.  Trim whitespace from both ends. then
            //  check to see which marker the line has.  Store the
            //  information to the appropriate buffer.
            //
            String s = addressReader.readLine() ;
            if (s == null)
                return false ;
            s.trim() ;
            if (s.startsWith(nameMarker))
            {
                name =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(telephoneMarker))
            {
                telephone =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(faxMarker))
            {
                fax =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(emailMarker))
            {
                email =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(addressMarker))
            {
                //
                //  Reached an address.  Get all the lines to the next
                //  totally blank line and treat them as the address.
                //
                StringBuffer sb = new StringBuffer(s.substring(
                    s.indexOf(markerEndCharacter)+1).trim()) ;
                //
                //  Pick up all the rest of the lines of the address
                //  up to the first fully blank line.  This ends the
                //  record.
                //
                while(true)
                {
                    s = addressReader.readLine() ;
                    if (s == null)
                        break ;
                    s.trim() ;
                    if (s.length() == 0)
                        break ;
                    //
                    //  Add the end of line marker (\\) and a newline
                    //  to the previous line before adding the next
                    //  one!  NB Must use \\ for each \ in \\!
                    //
                    sb.append("\\\\\n" + s) ;
                }
                address = sb.toString() ;
                completed = true ;
            }
            else
            {
                terminate(1, "Malformed address file.") ;
            }
        }
        information("\n    Name: " + name +
                    "\n    Telephone: " + telephone +
                    "\n    Fax: " + fax +
                    "\n    Address: " + address) ;
        return true ;
    }
    //
    //  Copy the source string to the returned string removing all
    //  markers and replacing them with the appropriate value.
    //
    private static String editMarkers(String s)
    {
        StringBuffer sb = new StringBuffer() ;
        while (s.length() != 0)
        {
            //
            //  See if the string actually has any possibility of a
            //  marker in it and if not simply copy the line and
            //  finish.  If there is the possibility of a marker copy
            //  the substring up to that point to the return value and
            //  remove it from the string.
            //
            int index = s.indexOf(markerStartCharacter) ;
            if (index < 0)
            {
                sb.append(s) ;
                break ;
            }
            sb.append(s.substring(0, index)) ;
            s = s.substring(index) ;
            //
            //  Check to see if this was entirely spurious, i.e. check
            //  to see if there is a close to the opening of the
            //  potential marker.  If it was spurious simply copy the
            //  rest of the line and return.
            //
            index = s.indexOf(markerEndCharacter) ;
            if (index < 0)
            {
                sb.append(s) ;
                break ;
            }
            //
            //  See if the potential marker was in fact a valid
            //  marker.  If it was then do the necessary output to the
            //  return value, otherwise copy and move on as ever.
            //
            if (s.startsWith(nameMarker))
            {
                sb.append(name) ;
            }
            else if (s.startsWith(telephoneMarker))
            {
                sb.append(telephone) ;
            }
            else if (s.startsWith(faxMarker))
            {
                sb.append(fax) ;
            }
            else if (s.startsWith(emailMarker))
            {
                sb.append(email) ;
            }
            else if (s.startsWith(addressMarker))
            {
                sb.append(address) ;
            }
            else
            {
                sb.append(s.substring(index)) ;
            }
            //
            //  Remove everything we have dealt with from the source
            //  string.
            //
            s = s.substring(index+1) ;
        }
        return sb.toString() ;
    }
    //
    //  Set off an external command, wait for it to terminate, check
    //  the return code and terminate if there was a problem.
    //
    private static void executeCommand(final String command)
        throws IOException, InterruptedException
    {
        //  Because there is no explicit object associated with this
        //  system, everything is static, we cannot call
        //  Runtime.exec() since this generates a:
        //
        //      "Can't make static reference to method
        //      java.lang.Process exec(java.lang.String) in class
        //      java.lang.Runtime."
        //
        //  error message.  We cannot create a Runtime object using a
        //  new, we must gain an handle onto a Runtime object using
        //  getRuntime().
        //
        //  NB.  MUST ensure that the commands terminate before the
        //  next begins.
        //
        Runtime runtime = Runtime.getRuntime() ;
        information(command) ;
        Process process = runtime.exec(command) ;
        process.waitFor() ;
        if (process.exitValue() != 0)
        {
            terminate(1, "Execution of \"" + command + "\" failed.") ;
        }
    }
}
//
//  The way of selecting the letter file name, the address file name
//  and the printer name.
//
class FilesSelector extends Dialog
{
    public FilesSelector(final MailMerge mm)
    {
        //
        //  Set up the Window itself with the Window title.  This has
        //  to done here as calls to super have to be the first action
        //  in the constructor.  Make the dialog modal.
        //
        super(mm, MailMerge.commandName + " Files Selection", true) ;
        //
        //  We need to remember as a member variable who our parent is
        //  for later when we spawn further dialogs since the various
        //  dialogs need to know who the parent Frame is as well and
        //  parameters to this constructor cannot suffice.
        //
        parent = mm ;
        //
        //  Set up the Panel with the instructions to the user.  The
        //  text is formatted using Labels and a GridLayout
        //  layout manager for ease and simplicity.
        //
        //  NB The strings used in each Label have been partitioned
        //  for no other reason that that we need to make the code fit
        //  onto a printed page and still be a compeltely executable
        //  program.  THIS IS A COMPLETE HACK AND SHOULD NEVER BE DONE
        //  IN A REAL PROGRAM.
        //
        Panel label = new Panel(new GridLayout(2, 1)) ;
        label.add(new Label("Please enter the names of the " +
                            " letter file, the address file")) ;
        label.add(new Label("  and, if the default is not to be " +
                            " used, the printer name")) ;
        //
        //  Set up the letter file name, address file name and printer
        //  name interaction boxes.
        //
        //  Wrap each component in a Panel so that the elements do not
        //  themselves get re-sized if the user re-sizes the
        //  FilesSelector box.  Could use a 1x3 GridLayout but use
        //  FlowLayout as it seems easier.
        //
        //  Associate a listener with each button to provide the
        //  necessary actions when the user presses the button.
        //
        //  NB BrowseButtonActionListener is an inner class of this
        //  one and hence has a parent pointer to its instatiating
        //  parent.  Every listener has to know who it's parent is
        //  after all!
        //
        //
        Panel letterSelector =
            new Panel(new FlowLayout(FlowLayout.LEFT)) ;
        letterSelector.add(new Label("Letter file")) ;
        letterSelector.add(letterField) ;
        Button b1 = new Button("Browse") ;
        b1.addActionListener(
            new BrowseButtonActionListener(letterField)) ;
        letterSelector.add(b1) ;
        //
        Panel addressSelector =
            new Panel(new FlowLayout(FlowLayout.LEFT)) ;
        addressSelector.add(new Label("Address file")) ;
        addressSelector.add(addressField) ;
        Button b2 = new Button("Browse") ;
        b2.addActionListener(
            new BrowseButtonActionListener(addressField)) ;
        addressSelector.add(b2) ;
        //
        Panel printerSelector =
            new Panel(new FlowLayout(FlowLayout.LEFT)) ;
        printerSelector.add(new Label("Printer name")) ;
        printerSelector.add(printerField) ;
        //
        //  Arrange the interaction Panels into a nice layout in a
        //  further Panel.  Use GridLayout layout manager since we
        //  know exactly how we want things organized, it is a stack
        //  of the three Panels.
        //
        Panel editFields = new Panel(new GridLayout(3, 1, 0, 10)) ;
        editFields.add(letterSelector) ;
        editFields.add(addressSelector) ;
        editFields.add(printerSelector) ;
        //
        //  Set up a button bar.  The OK button causes the
        //  FilesSelector to be terminated but execution to continue.
        //  The Clear button causes the field to be reset to the empty
        //  string but the dialog to remain the current focus.  The
        //  Cancel button is an exit button and causes execution of
        //  the command to terminate.
        //
        //  NB Anonymous classes are used here to save on the number
        //  of defined classes.  It allows the action declaration to
        //  be close to whre the action is.  Remember that these are
        //  inner classes and therefore keep a reference to their
        //  parent.  Any variable usage or method calls associated not
        //  understandable in the current object are assumed to be for
        //  the parent, cf. use of parent variable and dispose and
        //  repaint method calls.
        //
        Panel buttonBar =
            new Panel(new FlowLayout(FlowLayout.CENTER, 50, 5)) ;
        Button b3 = new Button("OK") ;
        b3.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent event)
                {
                    //
                    //  We set the data fields in the parent MailMerge
                    //  object from the data entered into the various
                    //  fields of the dialog box.  We then dispose of
                    //  ourself since we have served our purpose.
                    //
                    //  Cannot use mm here since that is a parameter
                    //  to the constructor and the object
                    //  instantiated here needs to have an object
                    //  variable rather than a method parameter to
                    //  make use of.
                    //
                    parent.letterFileName = letterField.getText() ;
                    parent.addressFileName = addressField.getText() ;
                    parent.printerName = printerField.getText() ;
                    dispose() ;
                }
            }
        ) ;
        buttonBar.add(b3) ;
        Button b4 = new Button("Cancel") ;
        b4.addActionListener(new ExitActionListener()) ;
        buttonBar.add(b4) ;
        Button b5 = new Button("Clear") ;
        b5.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent event)
                {
                    //
                    //  When this button is pushed, the user has asked
                    //  us to clear all the fields in our parent
                    //  dialog, so do it and refresh the window.
                    //
                    letterField.setText("") ;
                    addressField.setText("") ;
                    printerField.setText("") ;
                    repaint() ;
                }
            }
        ) ;
        buttonBar.add(b5) ;
        //
        //  Now add the three elements (the user instructions, the
        //  three interaction boxes with their buttons, and the button
        //  bar) to the main FilesSelector window.  To get the look we
        //  want, we have to use a full GridBagLayout.
        //
        setLayout(new GridBagLayout()) ;
        //
        //  We want the items in the Frame to appear one under the
        //  other.
        //
        GridBagConstraints gbc = new GridBagConstraints() ;
        gbc.gridx = 0 ;
        gbc.gridy = GridBagConstraints.RELATIVE ;
        //
        //  Actually add things in.  Use a blank Label as padding.
        //
        add(label, gbc) ;
        add(new Label(), gbc) ;
        add(editFields, gbc) ;
        add(new Label(), gbc) ;
        add(buttonBar, gbc) ;
        //
        //  Ensure that the window listens to the events the window
        //  manager sends us.  In fact we only listen out for
        //  termination events, we ignore all the others.
        //
        addWindowListener(new ExitWindowAdapter()) ;
        //
        //  Set the size by packing, attempt to mark the window as not
        //  re-sizable (though this does not work in JDK1.1.3) and
        //  then show the window.
        //
        pack() ;
        setResizable(false) ;
        setLocation(50, 50) ;
        setVisible(true) ;
    }
    //
    //  The three text fields that are used in the interaction.
    //
    private final TextField letterField = new TextField(20);
    private final TextField addressField = new TextField(20);
    private final TextField printerField = new TextField(20);
    //
    //  Dialogs have to know who their parent is.  Have to remember
    //  this as an object data item since we cannot make use of
    //  constructor parameters in the anonymous classes in which we
    //  need to know our parent.
    //
    private MailMerge parent ;
    //
    //  The action for all browse buttons is the same so we have a
    //  common class from which to instantiate the various listener
    //  objects.
    //
    //  This is an inner class and therefore objects of this class
    //  have access to their instantiating parent's state.  Every
    //  listener does have to know who its parent is after all!
    //
    private class BrowseButtonActionListener
        implements ActionListener
    {
        public BrowseButtonActionListener(final TextField t)
        {
            //
            //  The listener has to know which field it is being asked
            //  to fill when it is put into action.  We have to
            //  remember which one it is when we are set up so that we
            //  can access it when called upon to do so.
            //
            fieldToSet = t ;
        }
        //
        public void actionPerformed(final ActionEvent event)
        {
            //
            //  When the button is pressed, set off a FileDialog and
            //  await its completion.  When we are in charge again
            //  grab the information and put it into the field we were
            //  asked to fill and refresh the FilesSelector so that
            //  the new information appears on the user's screen.
            //  Finally dispose of the FileDialog as we are finished
            //  with it.
            //
            //  We need to give the FileDialog a parent, the only one
            //  available is the parent of the FilesSelector that
            //  initiated us (it is the root MailMerge Frame in fact)
            //  so use that.
            //
            FileDialog fd =
                new FileDialog(parent,
                               MailMerge.commandName +
                               " File Selector") ;
            fd.setLocation(25, 25) ;
            fd.setVisible(true) ;
            fieldToSet.setText(fd.getFile()) ;
            repaint() ;
            fd.dispose() ;
        }
        //
        //  Have to remember which field we have been asked to fill.
        //
        private TextField fieldToSet ;
    }
}
//
//  An echo to tell the user what is happening.
//
class Report extends Dialog
{
    public Report(final MailMerge mm)
    {
        //
        //  Even though this is a dialog just for information, we make
        //  it blocking (i.e. modal) so that the user has the
        //  opportunity to crash out if they got it wrong.
        //
        //  Put everything, especially Buttons, into Panels so that
        //  they are easily packable and don't have unexpected
        //  re-sizing behaviour.
        //
        super(mm, MailMerge.commandName, true) ;
        //
        //  The three items of information that we are giving the
        //  user.
        //
        Panel infoPanel = new Panel(new GridLayout(3, 1)) ;
        Panel letterPanel =
            new Panel(new FlowLayout(FlowLayout.LEFT)) ;
        letterPanel.add(new Label("Letter file:")) ;
        letterPanel.add(new Label(mm.letterFileName)) ;
        Panel addressPanel =
            new Panel(new FlowLayout(FlowLayout.LEFT)) ;
        addressPanel.add(new Label("Address file:")) ;
        addressPanel.add(new Label(mm.addressFileName)) ;
        Panel printerPanel =
            new Panel(new FlowLayout(FlowLayout.LEFT)) ;
        printerPanel.add(new Label("Printer:")) ;
        printerPanel.add(new Label(mm.printerName)) ;
        infoPanel.add(letterPanel) ;
        infoPanel.add(addressPanel) ;
        infoPanel.add(printerPanel) ;
        //
        //  We pause the activity by requiring OK button to be pressed
        //  to continue.  As ever the Cancel button causes program
        //  termination.
        //
        Panel buttonPanel = new Panel(new FlowLayout()) ;
        Button okButton = new Button("OK") ;
        okButton.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent event)
                {
                    //
                    //  All we have to do is let things continue so we
                    //  dispose of ourself and just let it all happen.
                    //
                    dispose() ;
                }
            }
        ) ;
        buttonPanel.add(okButton) ;
        Button cancelButton = new Button("Cancel") ;
        cancelButton.addActionListener(new ExitActionListener()) ;
        buttonPanel.add(cancelButton) ;
        //
        //  We want the items in the Frame to appear centred one under
        //  the other with the two panels of different heights.
        //
        setLayout(new GridBagLayout()) ;
        GridBagConstraints gbc = new GridBagConstraints() ;
        gbc.gridx = 0 ;
        gbc.gridy = GridBagConstraints.RELATIVE ;
        add(infoPanel, gbc) ;
        add(new Label(), gbc) ;
        add(buttonPanel, gbc) ;
        //
        //  Ensure that the window listens to the events the window
        //  manager sends us.  In fact we only listen out for
        //  termination events, we ignore all the others.
        //
        addWindowListener(new ExitWindowAdapter()) ;
        //
        //  Set the size by packing, attempt to mark the window as not
        //  re-sizable (though this does not work in JDK1.1.3 and then
        //  show the window.
        //
        pack() ;
        setResizable(false) ;
        setLocation(50, 50) ;
        setVisible(true) ;
    }
}
//
//  The text area into which all the information messages are put.
//
class MessageBox extends Frame
{
    public MessageBox(final String s)
    {
        //
        //  Set up a read-only scrollable text area to hold the
        //  messages.  Have a Hide button that simply hides the
        //  window.  Put the button into a Panel so that it doesn't
        //  start changing its size and shape.  Add the necessary
        //  listener.
        //
        super(s) ;
        ta.setEditable(false) ;
        setLayout(new BorderLayout()) ;
        add(BorderLayout.CENTER, ta) ;
        Panel buttonPanel = new Panel() ;
        Button hide = new Button("Hide") ;
        hide.addActionListener(
            new ActionListener()
            {
                public void actionPerformed(ActionEvent event)
                {
                    //
                    //  The hide method is deprecated so use the
                    //  proper method!
                    //
                    setVisible(false) ;
                }
            }
        ) ;
        buttonPanel.add(hide) ;
        add(BorderLayout.SOUTH, buttonPanel) ;
        //
        //  Set the size by packing, attempt to mark the window as
        //  re-sizable (though this does not work in JDK1.1.3, it is
        //  always re-sizable!).  Do not show this window at this
        //  time.  The window is constructed at load time and we need
        //  to wait to show it until the application needs it.
        //
        pack() ;
        setResizable(true) ;
        setLocation(50, 250) ;
    }
    //
    //  Add a new message to the message window.
    //
    public void append(final String s)
    {
        //
        //  Add the message to the text area and then show the window
        //  to let the user know that something has happened.
        //
        ta.append(s) ;
        setVisible(true) ;
    }
    //
    //  The TextArea that will actually hold the messages
    //
    private TextArea ta = new TextArea(20, 25) ;
}
//
//  A dialog supporting a run terminating problem.  Create a dialog
//  box in which to display a message.  Put the message string in and
//  also an OK button to terminate the dialog.  The dialog is
//  blocking, i.e. modal.
//
class TerminatingDialog extends Dialog
{
    public TerminatingDialog(final MailMerge mm,
                             final String s,
                             final int code)
    {
        //
        //  Set up the Frame ensuring we are a modal Dialog.
        //
        super(mm, MailMerge.commandName + " Error", true) ;
        setLayout(new GridLayout(2, 1, 0, 10)) ;
        //
        //  Add the message string to the window.
        //
        add(new Label(s, Label.CENTER)) ;
        //
        //  Put the button into a Panel so that it doesn't start
        //  changing its size and shape.  Pressing the OK button here
        //  is allowing the program to terminate so use an appropriate
        //  listener.
        //
        Panel buttonPanel = new Panel(new FlowLayout()) ;
        Button ok = new Button("OK") ;
        ok.addActionListener(new ExitActionListener()) ;
        buttonPanel.add(ok) ;
        add(buttonPanel) ;
        //
        //  Ensure that the window listens to the events the window
        //  manager sends us.  In fact we only listen out for
        //  termination events, we ignore all the others.
        //
        addWindowListener(new ExitWindowAdapter()) ;
        //
        //  Set the size by packing, attempt to mark the window as not
        //  re-sizable (though this does not work in JDK1.1.3), set
        //  the location of the window and make it red and then show
        //  the window.  This is a terminating dialog so as soon as
        //  the user has acknowledged the problem, terminate the
        //  complete program.
        //
        pack() ;
        setResizable(false) ;
        setLocation(100, 100) ;
        setBackground(Color.red) ;
        setVisible(true) ;
        //
        //  When the dialog is over, i.e. the user has pressed the OK
        //  button, then terminate the entire system.
        //
        System.exit(code) ;
    }
}
//
//  The listener for window closing signals from the window manager.
//
class ExitWindowAdapter extends WindowAdapter
{
    public void windowClosing(final WindowEvent event)
    {
        System.exit(0) ;
    }
}
//
//  The listener for cancel button action signals.
//
class ExitActionListener implements ActionListener
{
    public void actionPerformed(final ActionEvent event)
    {
        System.exit(0) ;
    }
}
//-------------------------------------------------------------------
//X-Sun-Data-Type: default
//X-Sun-Data-Name: mmerge.java
//X-Sun-Charset: us-ascii
//X-Sun-Content-Lines: 541

/**
 *  This code is from the book:
 *
 *    Winder, R and Roberts, G (1998) <em>Developing Java
 *    Software</em>, John Wiley & Sons.
 *
 *  It is copyright (c) 1997 Russel Winder and Graham Roberts.
 */

import java.io.* ;
//
//  A program to do a mail merge of a LaTeX2e letter class template
//  with an address file.  The address file contains records which
//  contain fields for name, telephone, fax, email and address.  For
//  each record, the LaTeX2e letter file is copied and edited and this
//  edited letter file "compiled" to DVI, processed to produce
//  PostScript and then the PostScript file spooled for printing.
//  Changing one of the constants would enable production of other
//  formats from DVI.  This program was developed on a UNIX
//  environment but should also be usable, possible perhaps with
//  amendments to the initial constants, on a Windows platform.
//
//  The LaTeX2e template is a standard LaTeX2e letter class file but
//  with the markers <NAME>, <TELEPHONE>, <FAX>, <EMAIL>, <ADDRESS>
//  replacing actual data.  The address file contains entries using
//  these markers as introducers, for example:
//
//      <NAME> A Person
//      <TELEPHONE> 0999 1234 1234
//      <FAX> 0999 4321 4321
//      <EMAIL> A.Person@somhost.or.other
//      <ADDRESS> 1 Some Street
//      A City
//      CountryX
//
//  Each record in the address file is terminated by a blank line.
//  The address must be the last field of the record but the others
//  can appear in any order.  Indeed they can appear many times but
//  the last entry for each field is the one used.
//
//  Version 1.0 24.5.97
//  Author Russel Winder
//
public class mmerge
{
    //
    //  The string constituting the summary of how to use the
    //  command.
    //
    private final static String usageString =
        "Usage: mmerge [-P...] <letter file> <addresses file>" ;
    //
    //  The strings for the various external commands that we are
    //  going to issue.  Also various strings to do with options and
    //  file names that are needed during command construction.
    //
    //  Serious issue regarding dvips and printing.  In my personal
    //  set up, dvips outputs to the standard output, it does not
    //  automatically send things to the printer.  Thus an explicit
    //  printing activity is required.  If this were C++, we would use
    //  the system(char*) function to handle the execution of the
    //  commands, which invokes the shell to interpret the command
    //  string -- this allows pipelining to be used, e.g. dvips
    //  file.dvi | lpr.  Runtime.exec(string) is the obvious analogue
    //  in Java but this does not use a shell to interpret commands.
    //  A design decision is required: Do we manage the files and
    //  manipulate things directly or do we spawn a shell to handle
    //  the pipelining.  Since spawning a shell leads to a shell that
    //  does not necessarily read the user's path, do things
    //  explicitly.  This is almost certainly less UNIX specific as
    //  well.
    //
    //  NB.  The print command has to be constructed at run time since
    //  the user may want to specify a particualr printer.
    //
    //  defaultPrinter is the empty string so that the print command
    //  uses the user's defaults.  Could have put something like
    //  "-PPostScript" but this would have made assumptions that are
    //  not really sensible.
    //
    private final static String defaultPrinter = "" ;
    private final static String printerParameterPrefix = "-P" ;
    private final static String tempFileRoot = "temp" ;
    private final static String latexExtender = ".ltx" ;
    private final static String dviExtender = ".dvi" ;
    private final static String psExtender = ".ps" ;
    //
    private final static String latexFileName =
        tempFileRoot + latexExtender ;
    private final static String dviFileName =
        tempFileRoot + dviExtender ;
    private final static String psFileName =
        tempFileRoot + psExtender ;
    //
    private final static String latexCommand =
        "latex " + latexFileName ;
    private final static String dvipsCommand =
        "dvips -o " + psFileName + " " + dviFileName ;
    private final static String printCommand = "lpr -h " ;
    //
    //  We need to remove all temporary files but we do not
    //  necessarily know all the file names that will be created; we
    //  know the root but not the extension.  Need to spawn a shell so
    //  that we can make use of wildcards in naming the files.  Need
    //  the quotes around the remove command to get the correct parse
    //  of the command.
    //
    //  Actually this does not seem to work, no files get removed.
    //  This is an, as yet, not understood problem.
    //
    private final static String deleteCommand =
        "sh -c \"rm -f " + tempFileRoot + ".*\"" ;
    //
    //  Strings to do with the markers that appear in the document
    //  template.
    //
    private final static char markerStartCharacter = '<' ;
    private final static char markerEndCharacter = '>' ;
    private final static String nameMarker =
        markerStartCharacter + "NAME" + markerEndCharacter ;
    private final static String telephoneMarker =
        markerStartCharacter + "TELEPHONE" + markerEndCharacter ;
    private final static String faxMarker =
        markerStartCharacter + "FAX" + markerEndCharacter ;
    private final static String emailMarker =
        markerStartCharacter + "EMAIL" + markerEndCharacter ;
    private final static String addressMarker =
        markerStartCharacter + "ADDRESS" + markerEndCharacter ;
    //
    //  There are some class scope data items.  This sort of data
    //  (accessible to all methods in the class) is usually considered
    //  a really bad idea but the justification here is as follows: To
    //  create an object (and hence class) to wrap these 4 data items
    //  seems like unecessary overkill but we cannot ask a method to
    //  return more than one item, thus the data items must be
    //  external to the method.
    //
    //  The data items are static since the methods are static and
    //  to do otherwise causes error messages from the compiler.
    //
    private static String name ;
    private static String telephone ;
    private static String fax ;
    private static String email ;
    private static String address ;
    //
    //  The program start point.
    //
    public static void main(String[] args)
        throws IOException, InterruptedException
    {
        //
        //  As a safety measure (in case we have forgotten to close
        //  any open files in the code, or in case an exception
        //  actually happens) we force all finalizers to be executed
        //  at termination of the program.  This ensures all files
        //  will be properly closed.
        //
        System.runFinalizersOnExit(true) ;
        //
        //  If the user gives no parameters, assume they are
        //  explicitly asking to know the syntax of use and that it is
        //  not an error.
        //
        if (args.length == 0)
        {
            terminate(0, usageString) ;
        }
        //
        //  Process the parameters.  Need to keep track of which
        //  parameter is the letter file and which the address file
        //  since we may have a printer specification as one of the
        //  parameters.
        //
        //  NB.  Unlike C++, the parameter list does not include the
        //  name of the command, just the parameters to it so the
        //  first parameter is in position 0 of the array.
        //
        int letterFileIndex = 0 ;
        int addressFileIndex = 1 ;
        String printerName = defaultPrinter ;
        //
        //  See if the first parameter starts with
        //  printerParameterPrefix.  If it does then the user has
        //  requested a specific printer so ensure we use it!
        //
        if (args[0].length() > 2)
        {
            if (args[0].substring(0, 2).
                compareTo(printerParameterPrefix) == 0)
            {
                printerName = printerParameterPrefix +
                              args[0].substring(2) ;
                letterFileIndex++ ;
                addressFileIndex++ ;
            }
        }
        //
        //  Check to make sure we have a viable set of parameters.
        //
        if (addressFileIndex >= args.length)
        {
            terminate(1, "Too few parameters given.\n"+usageString) ;
        }
        if (addressFileIndex < args.length - 1)
        {
            information("Excess parameter(s) ignored.") ;
        }
        //
        //  Set up the filenames and the file handles.
        //
        String letterFileName = args[letterFileIndex] ;
        String addressFileName = args[addressFileIndex] ;
        File letterFile = new File(letterFileName) ;
        File addressFile = new File(addressFileName) ;
        File latexFile = new File(latexFileName) ;
        File dviFile = new File(dviFileName) ;
        //
        //  Say what we are doing to give the user feedback.
        //
        information("Using letter in " + letterFileName +
                    " and addresses in " + addressFileName) ;
        //
        //  Open the address file and process all the people that the
        //  address file contains details about.
        //
        //  NB.  Must declare the variable outside the try block to
        //  avoid having the wrong scope.  Explicitly initialize the
        //  variable since although we can deduce that an apprently
        //  uninitialized must be initialized if the program
        //  continues, the compiler cannot and fails to compile the
        //  program!
        //
        BufferedReader addressReader = null ;
        try
        {
            addressReader =
                new BufferedReader(new FileReader(addressFile)) ;
        }
        catch (FileNotFoundException e)
        {
            terminate(1, "Could not open address file " +
                         addressFileName + ".") ;
        }
        while (getPerson(addressReader))
        {
            //
            //  Read the letter file and write it out to the temporary
            //  LaTeX2e file ready for "compiling".  Ensure all the
            //  edit field markers are replaced with appropriate
            //  information.
            //
            //  NB.  The variables are declared outside the try blocks
            //  to avoid wrong scope.  Initialize them with somethng
            //  to keep the compiler happy.
            //
            BufferedReader letterReader = null ;
            try
            {
                letterReader =
                    new BufferedReader(new FileReader(letterFile)) ;
            }
            catch (FileNotFoundException e)
            {
                terminate(1, "Could not open letter file " +
                             letterFileName + ".") ;
            }
            BufferedWriter latexWriter = null ;
            try
            {
                latexWriter =
                    new BufferedWriter(new FileWriter(latexFile)) ;
            }
            catch (FileNotFoundException e)
            {
                terminate(1, "Could not open temporary file " +
                             latexFileName + ".") ;
            }
            //
            //  We must ensure that LaTeX2e works in batch mode so
            //  that if it comes across an error in the processing it
            //  does not enter interactive mode.
            //
            latexWriter.write("\\batchmode") ;
            latexWriter.newLine() ;
            while (true)
            {
                //
                //  Get a line from the letter file, check it for
                //  occurrences of the markers, edit out the markers
                //  for the real information and output the (possibly)
                //  modified line.
                //
                String currentLine = letterReader.readLine() ;
                if (currentLine == null)
                    break ;
                currentLine = editMarkers(currentLine) ;
                latexWriter.write(currentLine) ;
                latexWriter.newLine() ;
            }
            //
            //  Finished this merge so close things up.  Remember to
            //  reset the eof flag and rewind the letter file so it's
            //  ready for the next addressee.
            //
            latexWriter.close() ;
            letterReader.close() ;
            //
            //  Create and run the latex command, and the printing
            //  command then delete all the temporary files ready
            //  for the next letter.
            //
            //  NB.  MUST ensure that the commands terminate before
            //  the next begins.
            //
            executeCommand(latexCommand) ;
            executeCommand(dvipsCommand) ;
            executeCommand(printCommand + printerName +
                           " " + psFileName) ;
            executeCommand(deleteCommand) ;
        }
        addressReader.close() ;
    }

    //
    //  Output a message to the user.
    //
    private static void information(final String s)
    {
        System.out.println(s) ;
    }

    //
    //  Output a message to the user and then stop execution.
    //
    private static void terminate(final int code, final String s)
    {
        information(s) ;
        System.exit(code) ;
    }

    //
    //  Get the details for the next person.  Can have any number of
    //  lines with any number of markers other than the address
    //  marker, followed by an address the end of which is the end of
    //  the record.  Obviously the last of any duplicates wins.
    //
    private static boolean
        getPerson(final BufferedReader addressReader)
        throws IOException
    {
        //
        //  Ensure that there is no carry over of information from one
        //  record to the next.
        //
        name = "" ;
        telephone = "" ;
        fax = "" ;
        address = "" ;
        //
        //  Do things until we get to the end of the record.
        //
        boolean completed = false ;
        while (! completed)
        {
            //
            //  Read a line.  Trim whitespace from both ends. then
            //  check to see which marker the line has.  Store the
            //  information to the appropriate buffer.
            //
            String s = addressReader.readLine() ;
            if (s == null)
                return false ;
            s.trim() ;
            if (s.startsWith(nameMarker))
            {
                name =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(telephoneMarker))
            {
                telephone =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(faxMarker))
            {
                fax =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(emailMarker))
            {
                email =
                  s.substring(s.indexOf(markerEndCharacter)+1).trim();
            }
            else if (s.startsWith(addressMarker))
            {
                //
                //  Reached an address.  Get all the lines to the next
                //  totally blank line and treat them as the address.
                //
                StringBuffer sb = new StringBuffer(s.substring(
                    s.indexOf(markerEndCharacter)+1).trim()) ;
                //
                //  Pick up all the rest of the lines of the address
                //  up to the first fully blank line.  This ends the
                //  record.
                //
                while(true)
                {
                    s = addressReader.readLine() ;
                    if (s == null)
                        break ;
                    s.trim() ;
                    if (s.length() == 0)
                        break ;
                    //
                    //  Add the end of line marker (\\) and a newline
                    //  to the previous line before adding the next
                    //  one!  NB Must use \\ for each \ in \\!
                    //
                    sb.append("\\\\\n" + s) ;
                }
                address = sb.toString() ;
                completed = true ;
            }
            else
            {
                terminate(1, "Malformed address file.") ;
            }
        }
        information("\tName: " + name +
                    "\n\tTelephone: " + telephone +
                    "\n\tFax: " + fax +
                    "\n\tAddress: " + address) ;
        return true ;
    }
    //
    //  Copy the source string to the returned string removing all
    //  markers and replacing them with the appropriate value.
    //
    private static String editMarkers(String s)
    {
        StringBuffer sb = new StringBuffer() ;
        while (s.length() != 0)
        {
            //
            //  See if the string actually has any possibility of a
            //  marker in it and if not simply copy the line and
            //  finish.  If there is the possibility of a marker copy
            //  the substring up to that point to the return value and
            //  remove it from the string.
            //
            int index = s.indexOf(markerStartCharacter) ;
            if (index < 0)
            {
                sb.append(s) ;
                break ;
            }
            sb.append(s.substring(0, index)) ;
            s = s.substring(index) ;
            //
            //  Check to see if this was entirely spurious, i.e. check
            //  to see if there is a close to the opening of the
            //  potential marker.  If it was spurious simply copy the
            //  rest of the line and return.
            //
            index = s.indexOf(markerEndCharacter) ;
            if (index < 0)
            {
                sb.append(s) ;
                break ;
            }
            //
            //  See if the potential marker was in fact a valid
            //  marker.  If it was then do the necessary output to the
            //  return value, otherwise copy and move on as ever.
            //
            if (s.startsWith(nameMarker))
            {
                sb.append(name) ;
            }
            else if (s.startsWith(telephoneMarker))
            {
                sb.append(telephone) ;
            }
            else if (s.startsWith(faxMarker))
            {
                sb.append(fax) ;
            }
            else if (s.startsWith(emailMarker))
            {
                sb.append(email) ;
            }
            else if (s.startsWith(addressMarker))
            {
                sb.append(address) ;
            }
            else
            {
                sb.append(s.substring(index)) ;
            }
            //
            //  Remove everything we have dealt with from the source
            //  string.
            //
            s = s.substring(index+1) ;
        }
        return sb.toString() ;
    }
    //
    //  Set off an external command, wait for it to terminate, check
    //  the return code and terminate if there was a problem.
    //
    private static void executeCommand(final String command)
        throws IOException, InterruptedException
    {
        //  Because there is no explicit object associated with this
        //  system, everything is static, we cannot call
        //  Runtime.exec() since this generates a:
        //
        //      "Can't make static reference to method
        //      java.lang.Process exec(java.lang.String) in class
        //      java.lang.Runtime."
        //
        //  error message.  We cannot create a Runtime object using a
        //  new, we must gain an handle onto a Runtime object using
        //  getRuntime().
        //
        //  NB.  MUST ensure that the commands terminate before the
        //  next begins.
        //
        Runtime runtime = Runtime.getRuntime() ;
        information(command) ;
        Process process = runtime.exec(command) ;
        process.waitFor() ;
        if (process.exitValue() != 0)
        {
            terminate(1, "Execution of \"" + command + "\" failed.") ;
        }
    }
}
