/*
 * Created on 2014.02.23.
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package runOnline;

/**
 * @author Rudi
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Date;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import fileAccess.ArticleDB;
import fileAccess.BaseDB;
import fileAccess.CustomerDB;
import fileAccess.LogWriter;
import fileAccess.SpecUtils;

public class Querying {
    static String _DataLib;
    static String _OutputLib;
    static String _WorkLib;
    static String _RecType;
    static String _CustNo;
    static String _ArtType;
    static final  String ERROR_MESSAGE_11 = "Illegal Query";
    static final  String ERROR_MESSAGE_12 = "Customer is not known";
    static final  String ERROR_MESSAGE_13 = "No Articles of this type are on stock";
    static PrintStream outputfile;
    public static boolean XMLParserForQuerying(String fileName) {
		 try {
			 SAXParserFactory factory = SAXParserFactory.newInstance();
			 SAXParser saxParser = factory.newSAXParser();
//				
//			<QUERY>
//			  <DIRECTORIES>
//			    <DataLib>Database</DataLib>
//			    <OutputLib>Outputs</OutputLib>
//			    <WorkLib>Work</WorkLib>
//			  </DIRECTORIES>
//			  <QUERY-DATA>
//			    <RecType>QU</RecType>
//			    <CustNo>009999</CustNo>
//			    <ArtType>MAGI</ArtType>
//			  </QUERY-DATA>
//			</QUERY>
//
			DefaultHandler handler = new DefaultHandler() {
		 
				boolean bfDataLib = false;
				boolean bfOutputLib = false;
				boolean bfWorkLib = false;
				boolean bfRecType = false;
				boolean bfCustNo = false;
				boolean bfArtType = false;

				public void startElement(String uri, String localName,String qName, 
			                Attributes attributes) throws SAXException {			 
					System.out.println("Start Element :" + qName);			 
					if (qName.equalsIgnoreCase("DataLib")) {
						bfDataLib = true;
					}			 
					if (qName.equalsIgnoreCase("OutputLib")) {
						bfOutputLib = true;
					}			 
					if (qName.equalsIgnoreCase("WorkLib")) {
						bfWorkLib = true;
					}			 
					if (qName.equalsIgnoreCase("RecType")) {
						bfRecType = true;
					}			 
					if (qName.equalsIgnoreCase("CustNo")) {
						bfCustNo = true;
					}			 
					if (qName.equalsIgnoreCase("ArtType")) {
						bfArtType = true;
					}			 
			 	}
			 
				public void endElement(String uri, String localName,
					String qName) throws SAXException {		 
					System.out.println("End Element :" + qName);			 
				}
				public void characters(char ch[], int start, int length) throws SAXException {	 
					if (bfDataLib) {
						System.out.println("DataLib : " + new String(ch, start, length));
						_DataLib =  new String(ch, start, length);
						bfDataLib = false;
					}			 
					if (bfOutputLib) {
						System.out.println("OutputLib : " + new String(ch, start, length));
						_OutputLib =  new String(ch, start, length);
						bfOutputLib = false;
					}			 
					if (bfWorkLib) {
						System.out.println("WorkLib : " + new String(ch, start, length));
						_WorkLib =  new String(ch, start, length);
						bfWorkLib = false;
					}			 
					if (bfRecType) {
						System.out.println("RecType : " + new String(ch, start, length));
						_RecType =  new String(ch, start, length);
						bfRecType = false;
					}			 
					if (bfCustNo) {
						System.out.println("CustNo : " + new String(ch, start, length));
						_CustNo =  new String(ch, start, length);
						bfCustNo = false;
					}			 
					if (bfArtType) {
						System.out.println("ArtType : " + new String(ch, start, length));
						_ArtType =  new String(ch, start, length);
						bfArtType = false;
					}			 
				}			 
		        };			 
		        saxParser.parse(fileName, handler);
		 
		    } catch (Exception e) {
		       e.printStackTrace();
		       return false;
		    }
		    return true; 
		}

    /**        
	 * @param args
	 */
	public static void main(String[] args)     
	       throws FileNotFoundException,IOException {
		final String lhdr = "| CustNo  CustName            ArtType Status  Date =  %1$tY%1$tm%1$td |";
		final String lhd2 = "|--------------------------------------------------------------|";
		final String lln2 = "| %1$-6s  %2$-20s%3$-8s%4$-24s |";
    try {    
		if (args.length == 0) 
    		{throw new RuntimeException("No input paramer supplied!");};
    		
    	SpecUtils.setRootDir("*");	
		if (!XMLParserForQuerying(SpecUtils.getRootDirRel(null,args[0]))) {
    		System.out.println("Problem with input XML message");
 	       	System.out.println("Press any key to finish");
 	       	System.in.read();
 	       	return;
		}
		
		System.out.println("Input Message was received");
		System.out.println("Customer No: " + _CustNo + " will be processed");
		LogWriter log = new LogWriter(SpecUtils.getRootDirRel("OUTPUTS","query.log.txt"));
		log.appendToLog(lhd2);
		log.appendToLog(String.format(lhdr, (new Date())));
		log.appendToLog(lhd2);
	
		BaseDB.ConnectToDB(SpecUtils.getRootDirRel(_DataLib));
		outputfile = new  PrintStream(SpecUtils.getRootDirRel(_OutputLib,"Response.xml"));
		ArticleDB article = new ArticleDB();
		CustomerDB customer = new CustomerDB();
        outputfile.println("<?xml version = \"1.0\" encoding = \"ISO-8859-1\"?>");
        outputfile.println("<!--DOCTYPE QUERYING SYSTEM \"Querying.xsd\"-->");
        outputfile.println("<QUERYING>");
        outputfile.println("<Request>");
        outputfile.println(SpecUtils.genXMLTag("RequesterNo",_CustNo));
        outputfile.println("</Request>");
        if (!_RecType.equals("QU")) {
	    	log.appendToLog(String.format(lln2,_CustNo
                    ,"" 
                    ,_ArtType
                    ,ERROR_MESSAGE_11));
            outputfile.println("</QUERYING>");
        	return;        	
        }
 
    	if (!customer.selectByCUST_NO(_CustNo)) {
            outputfile.println("<Response>");
            outputfile.println(SpecUtils.genXMLTag("ResponseArtNo","000000"));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtType",_ArtType));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtName",ERROR_MESSAGE_12));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtPrice",0));
            outputfile.println("</Response>");
            outputfile.println("</QUERYING>");
	    	log.appendToLog(String.format(lln2,_CustNo
                    ,customer.getCUST_NAME() 
                    ,_ArtType
                    ,ERROR_MESSAGE_12));
            return;
    	}
        
        int arttype_cnt = 0;
		article.startBrowseByART_TYPE(_ArtType);
        while (article. browseByART_TYPE()){
        	arttype_cnt++; 
            outputfile.println("<Response>");
            outputfile.println(SpecUtils.genXMLTag("ResponseArtNo",article.getART_NO()));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtType",article.getART_TYPE()));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtName",article.getART_NAME()));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtPrice",article.getART_PRICE()));
            outputfile.println("</Response>");
        }
        if (arttype_cnt == 0){
            outputfile.println("<Response>");
            outputfile.println(SpecUtils.genXMLTag("ResponseArtNo","000000"));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtType",_ArtType));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtName",ERROR_MESSAGE_13));
            outputfile.println(SpecUtils.genXMLTag("ResponseArtPrice",0));
            outputfile.println("</Response>");
	    	log.appendToLog(String.format(lln2,_CustNo
                    ,customer.getCUST_NAME() 
                    ,_ArtType
                    ,ERROR_MESSAGE_13));
        	
        }
        else {
	    	log.appendToLog(String.format(lln2,_CustNo
	    			                          ,customer.getCUST_NAME() 
	    			                          ,_ArtType
	    			                          ,arttype_cnt + " Articles were queried!"));
        }	
        outputfile.println("</QUERYING>");
    } catch (Exception e) {
	       e.printStackTrace();
	       System.out.println("Press any key to finish");
           System.in.read();
    }
    
	}


}
