import java.io.Console;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


/**
 * @author Daniel
 * @version 1.0
 * @created 26-Mai-2015 10:04:01
 */
public class CustomerOrder {

	private int OrderNumber;
	private int OrderAmount;
	private Date OrderDate;
	private Customer Customer;
	private List<OrderItem> OrderItems;
	private Invoice Invoice;
	private String PaymentInitials;
	private OrderItem OrderItem;
	
	private CustomerOrder vCustomerOrder;
	private List<OrderItem> oItems = new ArrayList<OrderItem>();
	private Article article;
	private Invoice inv;
	
	private static SessionFactory sessionFactory;

	public CustomerOrder(CustomerOrder cusOrder){
		this.OrderNumber = cusOrder.OrderNumber;
		this.OrderAmount = cusOrder.OrderAmount;
		this.OrderDate = cusOrder.OrderDate;
		this.Customer = cusOrder.Customer;
		this.OrderItems = cusOrder.OrderItems;
		this.Invoice = cusOrder.Invoice;
		this.PaymentInitials = cusOrder.PaymentInitials;
		this.OrderItem = cusOrder.OrderItem;
		
		setCustomerOrder(cusOrder);
	}


	/**
	 * 
	 * @param OrderNumber
	 */
	protected CustomerOrder getCustomerOrder(int OrderNumber){
		return this;
	}
	
	/**
	 * 
	 * @param CustomerOrder
	 */
	protected void setCustomerOrder(CustomerOrder CustomerOrder){
		if(this.Customer.getCustomerStatus(this.Customer).equals("good")) {
			// Create Order
			vCustomerOrder = CustomerOrder;	
			vCustomerOrder.OrderNumber = CreateNewOrderNumber();
			
			// Iterate over OrderItems
			oItems = vCustomerOrder.OrderItems;
			for(int i = 0; i < oItems.size(); i++) {
				article = oItems.get(i).getArticle();
				
				if(article.getArticleAmount(article) > oItems.get(i).getItemAmount()) {
					// Create and Write Object into XML
					DispatchItem.createDispatchItem(oItems.get(i));
					// Create and Write Object into XML
					BillingItem.createBillingItem(oItems.get(i));
					// Create Invoice
					inv = vCustomerOrder.Invoice;
					inv.setInvoice(new Invoice());
					// Deduct the Amount from an Article
					article.deductArticleAmount(article.getArticleNumber());
					// Check if SupplyOrderItem should be generated
					if(article.getArticleAmount(article) <= article.getMinimumAmount()) {
						// Create and Write Object into XML
						SupplyOrderItem.createSupplyItem(oItems.get(i));
					}
				} else {
					// Create and Write Object into XML
					BackOrderItem.createBackOrderItem(oItems.get(i));
					// Article is not part of the order because it is not available
					this.deleteArticleFromList(oItems.get(i));
				}	
			}
			
			vCustomerOrder.OrderItems = oItems;
			
			// Save CustomerOrder in DB with e.g. Hibernate
			saveOrder(vCustomerOrder);
			System.out.println("Order fullfilled");
			
		} else {
			rejectOrder(CustomerOrder.OrderNumber);
		}		
	}
	
	/**
	 * 
	 * @param cusOrder
	 */
	protected void saveOrder(CustomerOrder cusOrder) {
		sessionFactory = new Configuration().configure().buildSessionFactory();
		Session session = sessionFactory.getCurrentSession();
			try {
				session.beginTransaction();
				session.save(cusOrder);
				session.getTransaction().commit();
			} catch (HibernateException e) {
				e.printStackTrace();
				session.getTransaction().rollback();
			}
	}

	/**
	 * 
	 * @param OrderNumber
	 */
	protected String rejectOrder(int OrderNumber){
		System.out.println("reject");
		
		return "reject";
	}
	
	/**
	 * 
	 * @param
	 */
	protected int CreateNewOrderNumber() {
		int NewOrderNumber = SelectMaximumOrderNumber() + 1;
		return NewOrderNumber;
	}
	
	/**
	 * 
	 * @param OrderItem
	 */
	protected void deleteArticleFromList(OrderItem orderItem) {
		oItems.remove(orderItem);
	}
	
	/****************************************
	* GETTER / SETTER
	****************************************/
	public int getOrderNumber() {
		return OrderNumber;
	}
	public void setOrderNumber(int orderNumber) {
		OrderNumber = orderNumber;
	}
	public int getOrderAmount() {
		return OrderAmount;
	}
	public void setOrderAmount(int orderAmount) {
		OrderAmount = orderAmount;
	}
	public Date getOrderDate() {
		return OrderDate;
	}
	public void setOrderDate(Date orderDate) {
		OrderDate = orderDate;
	}
	public Customer getCustomer() {
		return Customer;
	}
	public void setCustomer(Customer customer) {
		Customer = customer;
	}
	public List<OrderItem> getOrderItems() {
		return OrderItems;
	}
	public void setOrderItems(List<OrderItem> orderItems) {
		OrderItems = orderItems;
	}
	public Invoice getInvoice() {
		return Invoice;
	}
	public void setInvoice(Invoice invoice) {
		Invoice = invoice;
	}
	public String getPaymentInitials() {
		return PaymentInitials;
	}
	public void setPaymentInitials(String paymentInitials) {
		PaymentInitials = paymentInitials;
	}
	public OrderItem getOrderItem() {
		return OrderItem;
	}
	public void setOrderItem(OrderItem orderItem) {
		OrderItem = orderItem;
	}	
}