import java.util.List;

class CustomerQuery {

	private Customer customer;

	public CustomerQuery(Customer cust) {
		if(cust.getCustomerStatus(cust).equals("good")) {
			this.customer = cust;
			getTypesForCustomer(cust);
		}
	}
	
	/**
	 * I only call the Method, because as you can see in the class diagram the implementation
	 * is in class Type
	 * @param cust
	 * @return
	 */
	protected List<Type> getTypesForCustomer(Customer cust) {
		return Type.getTypes(cust.getCustomerNumber());
	}
	
	/**
	 * I only call the Method, because as you can see in the class diagram the implementation
	 * is in class Article 
	 * @param typenumber
	 * @return
	 */
	protected List<Article> getArticlesForType(int typenumber) {
		return Article.selectArticleTypes(typenumber);
	}
	
	/**
	 * I only call the Method, because as you can see in the class diagram the implementation
	 * is in class Article
	 * @param orderAmount
	 * @param articleNumber
	 */
	protected void selectArticle(int orderAmount, int articleNumber) {
		Article.selectArticle(orderAmount, articleNumber);
	}
	
	/****************************************
	* GETTER / SETTER
	****************************************/
	public Customer getCustomer() {
		return customer;
	}
	public void setCustomer(Customer customer) {
		this.customer = customer;
	}
}
