/*
 * Created on 2014.02.20.
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fileAccess;
/**
 * @author Majnr Rudolf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
import java.io.FileNotFoundException;
import java.io.IOException;

import fileAccess.BaseDB;
import fileAccess.SpecUtils;

public class ArticleDB extends BaseDB {

	public ArticleDB() throws FileNotFoundException, IOException {
		super("article.csv");
	}        


    public String getART_REC_TYPE(){//   PIC XX VALUE 'AR'.
    	return getFieldByNumber(0);
    }
    public String getART_NO() {  // PIC 9(6).
    	return getFieldByNumber(1);
    }
    public String getART_TYPE() {  // PIC X(4).
    	return getFieldByNumber(2);
    }
    public int getART_AMOUNT() {  // PIC 9(6).
    	return SpecUtils.convertToInteger(getFieldByNumber(3));
    }
    public int getART_MINIMUM_AMOUNT() {  // PIC 9(6).
    	return SpecUtils.convertToInteger(getFieldByNumber(4));
    }
    public int getART_RESUPPLY_AMOUNT() {  // PIC 9(6).
    	return SpecUtils.convertToInteger(getFieldByNumber(5));
    }
    public String getART_STATUS() {  // PIC XX.
    	return getFieldByNumber(6);
    }
    public double getART_PRICE() {  // PIC 9999V99.
    	return SpecUtils.convertToDouble(getFieldByNumber(7));
    }
    public String getART_PRICE_AUS() {  // REDEFINES ART_PRICE PIC 9999.99.
    	return getFieldByNumber(7);
    }
    public String getART_NAME() {  // PIC X(30).
    	return getFieldByNumber(8);
    }

    public void setART_NO(String Value) {
    	setFieldByNumber(1,Value);
    }
    public void setART_TYPE(String Value) {
    	setFieldByNumber(2,Value);
    }
    public void setART_AMOUNT(int Value) {
    	setFieldByNumber(3,SpecUtils.convertIntToString (Value,4));
    }
    public void setART_MINIMUM_AMOUNT(int Value) {
    	setFieldByNumber(4,SpecUtils.convertIntToString (Value,4));
    }
    public void setART_RESUPPLY_AMOUNT(int Value) {
    	setFieldByNumber(5,SpecUtils.convertIntToString (Value,4));
    }
    public void setART_STATUS(String Value) {
    	setFieldByNumber(6,Value);
    }
    public void setART_PRICE(Double Value) {
       	setFieldByNumber(7,SpecUtils.convertDoubleToString (Value,2));
    }
    public void setART_NAME(String Value) {
    	setFieldByNumber(8,Value);
    }
    public void printContent(){
    	getRecordAt(0);
   		System.out.println(getRecordAt(0));
   		getFirstRealRecord();
   		do {
   			System.out.println(
   					        getART_REC_TYPE() + ";" +
                            getART_NO() + ";" +
                            getART_TYPE() + ";" +
                            getART_AMOUNT() + ";" +
                            getART_MINIMUM_AMOUNT() + ";" +
                            getART_RESUPPLY_AMOUNT() + ";" +
                            getART_STATUS() + ";" +
                            getART_PRICE() + ";" +
//                            getART_PRICE_AUS() + ";" +
                            getART_NAME() + ";"
                            );
   		} while (getNextRealRecord());
	}

    /**
     * Positions to the first real record after the header
     * @return false, if there is no  real record in DB
     */
    public boolean getFirstRealRecord() {
    	super.getFirstRecord();
    	while (!_eof) {
    		if (getART_REC_TYPE().equals("AR")) 
    			return true;
    		getNextRecord();
    	}
    	return false; 
    }
    
    /**
     * Positions to the next record 
     * @return false, if there is no  real record in DB
     */
    public boolean getNextRealRecord() {
    	if (_eof) return false;
    	super.getNextRecord();
    	return !_eof;
    }

    private String _searchKey;
    /**
     * Starts browsing by article type, goes to the top of file
     * @param searchKey
     */
    public void startBrowseByART_TYPE(String searchKey){
    	super.getFirstRecord();
    	_searchKey = searchKey;
    }
    /**
     * positions to the next record which meets the search criteria
     * @return true if found
     */
    public boolean browseByART_TYPE(){
    	if (_eof) return false;
    	super.getNextRecord();
    	while (!_eof) {
    		if (getART_TYPE().equals(_searchKey)) return true;
        	super.getNextRecord();
    	}
    	return false;
    }
    /**
     * Retrieves the first record meeting the search criteria
     * @param searchKey
     * @return true if found
     */
    public boolean selectByART_NO(String searchKey){
    	super.getFirstRecord();
    	while (!_eof) {
    		if (getART_NO().equals(searchKey)) 
    			return true;
    		getNextRecord();
    	}
    	return false;
    }
    /**
     * Writes a record at the end of the file
     * @param ART_NO
     * @param ART_TYPE
     * @param ART_AMOUNT
     * @param ART_MINIMUM_AMOUNT
     * @param ART_RESUPPLY_AMOUNT
     * @param ART_STATUS
     * @param ART_PRICE
     * @param ART_NAME
     */
    public void appendRecord(String ART_NO,
    		           String ART_TYPE,
    		           int ART_AMOUNT,
    		           int ART_MINIMUM_AMOUNT,
    		           int ART_RESUPPLY_AMOUNT,
    		           String ART_STATUS,
    		           double ART_PRICE,
    		           String ART_NAME) {
    	String newrec = "AR" +  ";" +
                        ART_NO + ";" +
                        ART_TYPE + ";" +
                        SpecUtils.convertIntToString(ART_AMOUNT,4) + ";" +
                        SpecUtils.convertIntToString(ART_MINIMUM_AMOUNT,4) + ";" +
                        SpecUtils.convertIntToString(ART_RESUPPLY_AMOUNT,4) + ";" +
                        ART_STATUS + ";" +
                        SpecUtils.convertDoubleToString(ART_PRICE,2) + ";" +
                        ART_NAME + ";";
    	
    	super.appendRecord(newrec);
    }
    public void insertRecord(String ART_NO,
	           String ART_TYPE,
	           int ART_AMOUNT,
	           int ART_MINIMUM_AMOUNT,
	           int ART_RESUPPLY_AMOUNT,
	           String ART_STATUS,
	           double ART_PRICE,
	           String ART_NAME) {
        String newrec = "AR" +  ";" +
                     ART_NO + ";" +
                     ART_TYPE + ";" +
                     SpecUtils.convertIntToString(ART_AMOUNT,4) + ";" +
                     SpecUtils.convertIntToString(ART_MINIMUM_AMOUNT,4) + ";" +
                     SpecUtils.convertIntToString(ART_RESUPPLY_AMOUNT,4) + ";" +
                     ART_STATUS + ";" +
                     SpecUtils.convertDoubleToString(ART_PRICE,2) + ";" +
                     ART_NAME + ";";

        super.insertRecord(newrec);
}

}

