/*
 * Created on 2014.02.20.
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fileAccess;

import static java.lang.Math.floor;
import java.io.File;
import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * @author Rudi           
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SpecUtils {
   static String ToolRootDir;
   /**
    * Sets the static ToolRootDir variable of the class
    * @param rootDir
    */
   public static void setRootDir(String rootDir) {
	  File ToolRootDirFile; 
      if (rootDir == "*") 
    	  ToolRootDir = System.getProperty("user.dir");
      else {
    	  ToolRootDirFile = new File(rootDir);
          if (!ToolRootDirFile.exists() ) 
             throw new RuntimeException(ToolRootDirFile.getAbsolutePath() + " doesn't exist");
    	  ToolRootDir = ToolRootDirFile.getAbsolutePath();
      
      }    
	  System.out.println("Running with ToolRootDir " + ToolRootDir);
   } 
   /**
    * Returns an absolute directory path 
    * @param relDir
    * @return
    */
   public static String getRootDirRel(String relDir) {
       if (relDir == null)
 	       relDir = includeTrailingBackSlash(ToolRootDir);
       else
       {
           File WFile = new File(relDir);
           if (WFile.isAbsolute())
    	       relDir = includeTrailingBackSlash(relDir);
           else
	           relDir = includeTrailingBackSlash(ToolRootDir) + includeTrailingBackSlash(relDir) ;
       }    
	   return relDir;
   } 
   /**
    * Returns an absolute file path 
    * @param relDir
    * @param fileName
    * @return
    */
   public static String getRootDirRel(String relDir,String fileName) {
	   return getRootDirRel(relDir) + fileName;
   } 

   /**
    * This method converts a string value to an integer.
    * @param stringValue The string representation of an integer
    * @return The native integer representation of a number string
    */
    public static int convertToInteger(String stringValue) {
    	 stringValue = stringValue.trim();
    	 if (stringValue.matches(NumericMatch)) {
    		 return (new Integer(stringValue).intValue());
    	 }
    	 else {
    		 return 0;
    	 }
    }
    /**
     * This method converts an integer value into a string representation.
     * @param intValue The integer value
     * @return The string representation of the integer value
     */
    public static String convertIntToString (int intValue) {
        return (new Integer(intValue)).toString();
      }

    /**
     * This method converts an integer value into a string representation with a given length.
     * @param intValue The integer value
     * @param length The length of the returned string
     * @return The string representation of the integer value
     */
    public static String convertIntToString (int intValue,int length) {
        char[] staticStorage = new char[length];
        String source = convertIntToString (Math.abs(intValue));
        char[] asource = source.toCharArray(); 
        int position = 0;
        int k = 0;
        int end = position + length;
        for (int i = end-1,j = source.length()-1;i >= position; i--,j--) {
            if (j >= k) staticStorage [i] = asource[j];
              else
                staticStorage [i] = '0';
         }
        return new String(staticStorage);
    }
    /**
     * This method converts a string value to a double.
     * @param doubleValue The string representation of a double
     * @return The native double representation of a number string
     */
    public static double convertToDouble (String doubleValue) {
      	doubleValue = doubleValue.trim();
     	 	if (doubleValue.matches(doubleMatch)) {
     	 		return (double) (new Double(doubleValue).doubleValue());
     	 	} 
     	 	else { 
     	 		return 0;
     	 	}
      }
      /**
       * This method converts a double value into a string representation.
       * @param doubleValue The double value
       * @param precision the required precision
       * @return The string representation of the double value
       */
      public static String convertDoubleToString (Double doubleValue, int precision) {
    	  BigDecimal bg1 = new BigDecimal(doubleValue);
    	  return  bg1.setScale(precision, RoundingMode.HALF_DOWN).toString();
      }
      /**
       * This method returns a truncated double value as integer.
       * @param doubleValue The double value
       * @return The truncated double value as integer
       */
      public static int roundDouble (double doubleValue) {
          return new Integer((int)(floor(doubleValue))).intValue() ;
        }
    /**
     * Adds a trailing backslash to a file name if not present
     * @param path
     * @return
     */
    public static String includeTrailingBackSlash(String path) {
        if(path.charAt(path.length()-1)!=File.separatorChar)
            return path + File.separator;
        else
        	return path;
    }
    /**
     * 
     * @param Tag
     * @param Value
     * @return
     */
    public static String genXMLTag(String Tag,String Value) {
    	return "<" + Tag + ">" + Value + "</" + Tag + ">";
    }
    /**
     * 
     * @param Tag
     * @param Value
     * @return
     */
    public static String genXMLTag(String Tag,int Value) {
    	return "<" + Tag + ">" + Value + "</" + Tag + ">";
    }
    /**
     * 
     * @param Tag
     * @param Value
     * @return
     */
    public static String genXMLTag(String Tag,double Value) {
    	return "<" + Tag + ">" + Value + "</" + Tag + ">";
    }
    /**   Class conditions */
    /**
     * Used for testing a field for numeric characters
     */
    public static final String AlphabeticMatch = "[ \\p{Alpha}]+"; 
    /**
     * Used for testing a field for numeric characters
     */
    public static final String NumericMatch = "(-?|\\+?)\\p{Digit}+";
    /**
     * Used for testing a field for double eligibility
     */
    public static final String doubleMatch = "^([+-]?(\\d+\\.)?\\d+)$";
//    String doubleRegexp="^([+-]?(\\d+\\.)?\\d+)$";
    
//    or if you look also in the middle of other text:
//    String doubleRegexp="([+-]?(\\d+\\.)?\\d+)";
    
//    and if you don't look for the minus/plus sign:
//    String doubleRegexp="^(\\d+\\.)?\\d+$";
//    try {
//        double.parsedouble(string)
//        return true;
//   }
//   catch (NumberFormatException ex) {
//        return false;
//   }
}
